#include <cpctelera.h>
#include <stdio.h>
#include <string.h>
#include "main.h"
#include "fonts.h"
#include "funciones.h"
#include "textos_eng.h" //Para textos en ingles
//#include "textos_spa.h" //Para textos en español

void initTxtSuperior(){
	cpct_drawSolidBox (cpct_getScreenPtr(CPCT_VMEM_START,  0, 0), 255, 40, AREA_JUEGO_SUPERIOR_INI); // El procedimiento tiene un límite de 64 bytes de ancho, por eso se hace en dos partes
	cpct_drawSolidBox (cpct_getScreenPtr(CPCT_VMEM_START, 40, 0), 255, 40, AREA_JUEGO_SUPERIOR_INI); // patrón de relleno: 255 => 111111111 Todo pintado (blanco)

	cpct_drawSolidBox (cpct_getScreenPtr(CPCT_VMEM_START,  1, 1), 0, 40, AREA_JUEGO_SUPERIOR_INI-2); // patrón de relleno: 0 => 00000000 Todo vacío (negro)
	cpct_drawSolidBox (cpct_getScreenPtr(CPCT_VMEM_START, 41, 1), 0, 38, AREA_JUEGO_SUPERIOR_INI-2);
}

void initTxtInferior(){
	cpct_drawSolidBox (cpct_getScreenPtr(CPCT_VMEM_START,  0, AREA_JUEGO_INFERIOR+1), 255, 40, 18); // El procedimiento tiene un límite de 64 bytes de ancho, por eso se hace en dos partes
	cpct_drawSolidBox (cpct_getScreenPtr(CPCT_VMEM_START, 40, AREA_JUEGO_INFERIOR+1), 255, 40, 18);
	cpct_drawSolidBox (cpct_getScreenPtr(CPCT_VMEM_START,  1, AREA_JUEGO_INFERIOR+2), 0, 40, 16);
	cpct_drawSolidBox (cpct_getScreenPtr(CPCT_VMEM_START, 41, AREA_JUEGO_INFERIOR+2), 0, 38, 16);
}

void txtSupIntro(){

	initTxtSuperior();
	f_c = cpct_getScreenPtr(CPCT_VMEM_START, 2, 2);
	myDrawString(txtIntro1);
	myDrawString(txtIntro2);
	myDrawString(txtIntro3);
	myDrawString(txtIntro4);	

	//Restaurar Marcador por si se ha llegado a nivel 6, si no seguiría mostrando energía de nave nodriza
	for (vista_pulsada=50; vista_pulsada < 70; vista_pulsada++){
		*(u8*)&txtMarcador[vista_pulsada] = 45;
	}
	*(u8*)&txtMarcador[vista_pulsada] = 255;		
}


void txtInfCreditos(){
	//Créditos
	initTxtInferior();
	f_teletipo = 0;
	f_c = cpct_getScreenPtr(CPCT_VMEM_START, 2, 187);	
	myDrawString(txtCreditos);
}


void txtSupFase1(){

	initTxtSuperior();
	f_c = cpct_getScreenPtr(CPCT_VMEM_START, 2, 2);
	f_teletipo = 1; 
	myDrawString(txtFase1_1);
	myDrawString(txtFase1_2);
	myDrawString(txtFase1_3);
	myDrawString(txtFase1_4);
}

void txtSupFase2(){

	initTxtSuperior();
	f_c = cpct_getScreenPtr(CPCT_VMEM_START, 2, 2);
	f_teletipo = 1; 
	myDrawString(txtFase2_1);
	myDrawString(txtFase2_2);
	myDrawString(txtFase2_3);
}

void pintarRestanteNivel3(){
	u8 j;
	j = timeline/64;

	f_c = cpct_getScreenPtr(CPCT_VMEM_START, 2 + j, 27);
	myDrawString(txtFase3_4);
}

void txtSupFase3(){
	u8 i;

	initTxtSuperior();
	f_c = cpct_getScreenPtr(CPCT_VMEM_START, 2, 2);
	f_teletipo = 1; 
	myDrawString(txtFase3_1);
	myDrawString(txtFase3_2);
	myDrawString(txtFase3_3);
	//Inicializar Progreso
	for (i=0; i < 32; i++){
		*(u8*)&txtFase3_4[i] = 49;
	}
	*(u8*)&txtFase3_4[i] = 255;
	f_teletipo = 0; 
	myDrawString(txtFase3_4);
	//pintarRestanteNivel3();
	//Preparar para ir pintando espacios encima cada vez que se llegue a una actualización del progreso
	*(u8*)&txtFase3_4[0] = 45;
	*(u8*)&txtFase3_4[1] = 45;
	*(u8*)&txtFase3_4[2] = 255;
}

void txtSupFase4(){
	initTxtSuperior();
	f_c = cpct_getScreenPtr(CPCT_VMEM_START, 2, 2);
	f_teletipo = 1; 
	myDrawString(txtFase4);
}

void pintarEnergiaNodriza(){
	u8 i;

	for (i=50; i - 50 < enemigos; i++){
		*(u8*)&txtMarcador[i] = 49;
	}

	while (i < 70) {
		*(u8*)&txtMarcador[i++] = 45;
	}

	*(u8*)&txtMarcador[i] = 255;

	f_c = cpct_getScreenPtr(CPCT_VMEM_START, 2, 187);
	f_teletipo = 0; 
	myDrawString(txtMarcador);
}

void txtSupFinal(){

	initTxtSuperior();
	f_c = cpct_getScreenPtr(CPCT_VMEM_START, 2, 2);
	f_teletipo = 1; 
	myDrawString(txtFinal1);
	if (cheat)
		*(u8*)&txtFinal2[41] = 255;
	else
		*(u8*)&txtFinal2[41] = 45;
	myDrawString(txtFinal2);
	myDrawString(txtContinue);
}

void actualizarMarcador(){
	u16 temp;

	//puntos
	temp = puntuacion;

	//hack para cambiar variables declaradas como constantes. No recomendable pero útil en este caso para ahorrar código (Si no se declara como const, entonces
	//hay que asignarle valor a toda la tabla con el consiguiente aumento de código, pues las variables globales que no sean const, se inicializan a 00 aunque se les ponga valor en C)
	//Como no se usan decenas ni unidades para puntos, realmente se guarda 100 pts como 1 pt para ahorrar luego cálculos
	*(u8*)&txtMarcador[6] = temp / 100;
	temp = temp % 100;
	*(u8*)&txtMarcador[7] = temp / 10;
	temp = temp % 10;
	*(u8*)&txtMarcador[8] = temp;
	/*No hay puntos por decenas ni unidades en el juego, no es necesario cambiar el 0 inicial
	temp = temp % 100;
	*(u8**)&txtMarcador[9] = 0;
	temp = temp % 10;
	*(u8**)&txtMarcador[10] = 0;*/
	
	if (vidas < 3)	
		*(u8*)&txtMarcador[22] = 45;
	else
		*(u8*)&txtMarcador[22] = 48;

	if (vidas < 2)	
		*(u8*)&txtMarcador[21] = 45;
	else
		*(u8*)&txtMarcador[21] = 48;

	if (vidas < 1)	
		*(u8*)&txtMarcador[20] = 45;
	else
		*(u8*)&txtMarcador[20] = 48;
}

void txtInfMarcador(){
	

	//initTxtInferior();
	f_teletipo = 0;
	f_c = cpct_getScreenPtr(CPCT_VMEM_START, 2, 187);	
	
	actualizarMarcador();
	myDrawString(txtMarcador);
}

void txtSupPuntuacionFinal(){

	cpct_drawSolidBox (cpct_getScreenPtr(CPCT_VMEM_START,  0, 0), 255, 40, 24); 
	cpct_drawSolidBox (cpct_getScreenPtr(CPCT_VMEM_START,  1, 1), 0, 38, 22); // patrón de relleno: 0 => 00000000 Todo vacío (negro)


	f_teletipo = 0;
	f_c = cpct_getScreenPtr(CPCT_VMEM_START, 2, 2);	
	*(u8*)&txtMarcador[11] = 255; //Reutilizo marcador poniéndole fin de línea antes del cartel de vidas
	myDrawString(txtMarcador);
	*(u8*)&txtMarcador[11] = 45; //Vuelvo a dejar el marcador como estaba

	*(u8*)&txtTiempoTotal[5] = speedrun_digitos[3]; // Decena de minutos 300 interrupciones = 1 segundo
	*(u8*)&txtTiempoTotal[6] = speedrun_digitos[2];	  // Unidades de minutos

	*(u8*)&txtTiempoTotal[17] = speedrun_digitos[1]; // Decena de segundos
	*(u8*)&txtTiempoTotal[18] = speedrun_digitos[0]; // Unidades de segundos

	myDrawString(txtTiempoTotal);
	*(u8*)&txtTiempoTotal[27] = 45;  //Quito marca de bonus speedrun por si se puso
}

void txtInfNombrePuntuacion(){
	initTxtInferior();
	f_teletipo = 0;
	f_c = cpct_getScreenPtr(CPCT_VMEM_START, 2, 187);	

	myDrawString(txtNombre);
}

void txtInfContinuar(){
	myDrawString(txtContinue);
	pausaTecladoLibre();
	while (!tecladoPulsado());
	pausaTecladoLibre();
}

void txtMedPausa(){
	f_teletipo = 0;
	f_c = cpct_getScreenPtr(CPCT_VMEM_START, 35, 70);	

	myDrawString(txtPausa);
}

void txtSupTutorial1(){

	initTxtSuperior();
	f_c = cpct_getScreenPtr(CPCT_VMEM_START, 2, 2);
	f_teletipo = 1; 
	myDrawString(txtTutorial1_1);
	//cambiar teclado XD. No importa destruir mensaje original porque no se volverá a usar
	*(u8*)&txtTutorial1_1[0] = 26;
	*(u8*)&txtTutorial1_1[1] = 10;
	*(u8*)&txtTutorial1_1[2] = 24;
	*(u8*)&txtTutorial1_1[3] = 25;
	*(u8*)&txtTutorial1_1[4] = 255;

	f_c = cpct_getScreenPtr(CPCT_VMEM_START, 34, 2);
	myDrawString(txtTutorial1_1);

	f_c = cpct_getScreenPtr(CPCT_VMEM_START, 2,11);
	myDrawString(txtTutorial1_2);
}

void txtSupTutorial2(){
	initTxtSuperior();
	f_c = cpct_getScreenPtr(CPCT_VMEM_START, 2, 2);
	f_teletipo = 1; 
	myDrawString(txtTutorial2_1);
	myDrawString(txtTutorial2_2);
}

void txtSupTutorial3(){
	initTxtSuperior();

	initTxtSuperior();
	f_c = cpct_getScreenPtr(CPCT_VMEM_START, 2, 2);
	f_teletipo = 1; 
	myDrawString(txtTutorial3_1);
}

void txtSupTutorial4(){
	initTxtSuperior();

	initTxtSuperior();
	f_c = cpct_getScreenPtr(CPCT_VMEM_START, 2, 2);
	f_teletipo = 1; 
	myDrawString(txtTutorial4_1);
}
