; declar en C (fichero .h) como void cpct_drawSpriteBlended_NAND (u8* memory, u8 height, u8 width, const u8* sprite) __z88dk_callee;
;
; los parámetros se meten en la pila de izquierda a derecha, siendo primero la dirección de retorno
;
; Función para borrar la silueta del sprite.
; Porque cpct_drawSpriteBlended con XOR no funciona si el sprite original ha sido borrado por el proceso de dibujado de otro sprite, 
; es decir, cuando dos sprites ocupan el mismo pixel, pero el juego continúa. No hay "muerte".
; Para ello se recorre el sprite por la pantalla de vídeo poniendo todos sus 1's a 0's  (contenido_memoria AND ~sprite)

.globl _cpct_drawSpriteBlended_NAND
_cpct_drawSpriteBlended_NAND::

   pop  hl     ;dirección retorno
   pop  de     ;*memory 
   pop  bc     ;height and width
   ex (sp), hl ;*sprite en hl y dejar dirección de retorno en pila

   push ix         
   .DW  #0x68DD ;LD IXL, B       

height_loop_NAND:
   push de         

width_loop_NAND:
   ld     a,(de)   

_cpct_dsb_blendFunction_NAND::
   xor #0xFF   ; (contenido_memoria AND ~sprite) es lo mismo que  ~(~contenido_memoria OR sprite). Y ~ se hace con XOR 0xFF
   or (hl)
   xor #0xFF  
   ld  (de), a     
   inc   de        
   inc   hl        
   djnz  width_loop_NAND
   pop  de         
   dec   c         
   jr    z,copy_ended_NAND
   .DW  #0x45DD ;LD B, IXL       
   ld    a, d      
   add   #0x08     
   ld    d, a      
   and   #0x38     
   jr   nz,height_loop_NAND 

_8bit_boundary_crossed_NAND:
   ld    a, e      
   add   #0x50     
   ld    e, a      
   ld    a, d      
   adc   #0xC0     
   ld    d, a      
   jr  height_loop_NAND

copy_ended_NAND:
   pop  ix  
   ret    