﻿#include "fonts.h"
#include <cpctelera.h>

unsigned char f_teletipo = 1;
unsigned char *f_c; //Puntero de memoria de vídeo donde pintar carácter con myDrawChar
//const unsigned char*  f_l[MAX_CHARS_PER_LINE]; //Array de la línea de caracteres a pintar, con puntero a los sprites

void myDrawString (unsigned char* f_l) { //fastcall optimiza cuando sólo hay un parámetro. No usa pila(push/pop), sólo registro HL
	
	//Función propia para dibujar mis caracteres (sprites) para optimizar pues siempre tienen el mismo tamaño y 
	//la dirección de vídeo a pintar está en una variable global
	unsigned char i,j,eol;
	eol = 0;
	for (i=0; i<MAX_CHARS_PER_LINE; i++){
		for (j=0; j<8;j++){			
			if (f_l[i] == 0xFF){ //Fin de línea, salir
				eol = 1;
			}
 //Si hemos llegado a carácter fin de línea dejamos de escribir en memoria de vídeo y sólo hacemos los cálculos para ir actualizando el puntero
			if (!eol)
				*f_c = *( &G_S0[0] + (u16) (8*f_l[i]) + j);  //Teniendo como base el primer sprite le sumamos el desplazamiento indicado (multiplicado por su tamaño, que es 8) y ya cogemos la fila en cuestión: 1 byte

			f_c += 0x0800;
			if (!((int) f_c & 0x3800)) //Detectar si la dirección resultante lleva a final de línea de 8 bits => cambiar de banco de vídeo
				f_c += 0xC050;

			cpct_scanKeyboard_f();
		   	if ( cpct_isAnyKeyPressed_f ())
				f_teletipo = 0;
		}
		f_c -= 0x04F; //Volver al banco anterior - 0x50 e ir a la siguiente casilla + 0x01
		if (f_teletipo && !eol)
			for (int i = 0; i < 5000; ++i) //Bucle espera para simular teletipo
				;
	}
}

const unsigned char G_S0[8] = { 
	0x00, 
	0x00, 
	0x3C, 
	0x42, 
	0x42, 
	0x42, 
	0x3C, 
	0x00};


const unsigned char G_S1[8] = { 
	0x00, 
	0x00, 
	0x38, 
	0x08, 
	0x08, 
	0x08, 
	0x3C, 
	0x00};


const unsigned char G_S2[8] = { 
	0x00, 
	0x00, 
	0x38, 
	0x04, 
	0x3C, 
	0x20, 
	0x3C, 
	0x00};


const unsigned char G_S3[8] = { 
	0x00, 
	0x00, 
	0x78, 
	0x04, 
	0x38, 
	0x04, 
	0x78, 
	0x00};


const unsigned char G_S4[8] = { 
	0x00, 
	0x00, 
	0x44, 
	0x44, 
	0x3C, 
	0x04, 
	0x04, 
	0x00};


const unsigned char G_S5[8] = { 
	0x00, 
	0x00, 
	0x3C, 
	0x20, 
	0x3C, 
	0x04, 
	0x38, 
	0x00};


const unsigned char G_S6[8] = { 
	0x00, 
	0x00, 
	0x40, 
	0x40, 
	0x7C, 
	0x44, 
	0x7C, 
	0x00};


const unsigned char G_S7[8] = { 
	0x00, 
	0x00, 
	0x7C, 
	0x04, 
	0x08, 
	0x10, 
	0x10, 
	0x00};


const unsigned char G_S8[8] = { 
	0x00, 
	0x00, 
	0x3C, 
	0x44, 
	0x7C, 
	0x44, 
	0x7C, 
	0x00};


const unsigned char G_S9[8] = { 
	0x00, 
	0x00, 
	0x3C, 
	0x44, 
	0x7C, 
	0x04, 
	0x04, 
	0x00};


const unsigned char G_a[8] = { 
	0x00, 
	0x00, 
	0x78, 
	0x04, 
	0x7C, 
	0x84, 
	0x7C, 
	0x00};


const unsigned char G_b[8] = { 
	0x80, 
	0x80, 
	0x80, 
	0xF8, 
	0x84, 
	0x84, 
	0xFC, 
	0x00};


const unsigned char G_c[8] = { 
	0x00, 
	0x00, 
	0x7C, 
	0x80, 
	0x80, 
	0x80, 
	0x7C, 
	0x00};


const unsigned char G_d[8] = { 
	0x04, 
	0x04, 
	0x04, 
	0x7C, 
	0x84, 
	0x84, 
	0xFC, 
	0x00};


const unsigned char G_e[8] = { 
	0x00, 
	0x00, 
	0x78, 
	0x84, 
	0xF8, 
	0x80, 
	0x7C, 
	0x00};


const unsigned char G_f[8] = { 
	0x3C, 
	0x40, 
	0x40, 
	0x78, 
	0x40, 
	0x40, 
	0x40, 
	0x00};


const unsigned char G_g[8] = { 
	0x00, 
	0x7C, 
	0x84, 
	0x84, 
	0x7C, 
	0x04, 
	0x84, 
	0x78};


const unsigned char G_h[8] = { 
	0x80, 
	0x80, 
	0x80, 
	0xF8, 
	0x84, 
	0x84, 
	0x84, 
	0x00};


const unsigned char G_i[8] = { 
	0x00, 
	0x10, 
	0x00, 
	0x10, 
	0x10, 
	0x10, 
	0x10, 
	0x00};


const unsigned char G_j[8] = { 
	0x10, 
	0x00, 
	0x10, 
	0x10, 
	0x10, 
	0x10, 
	0x10, 
	0xF0};


const unsigned char G_k[8] = { 
	0x80, 
	0x80, 
	0x8C, 
	0xB0, 
	0xE0, 
	0xB0, 
	0x8C, 
	0x00};


const unsigned char G_l[8] = { 
	0x20, 
	0x20, 
	0x20, 
	0x20, 
	0x20, 
	0x20, 
	0x38, 
	0x00};


const unsigned char G_m[8] = { 
	0x00, 
	0x00, 
	0x00, 
	0x7E, 
	0x92, 
	0x92, 
	0x92, 
	0x00};


const unsigned char G_n[8] = { 
	0x00, 
	0x00, 
	0x00, 
	0x3C, 
	0x44, 
	0x44, 
	0x44, 
	0x00};


const unsigned char G_o[8] = { 
	0x00, 
	0x00, 
	0x78, 
	0x84, 
	0x84, 
	0x84, 
	0x78, 
	0x00};


const unsigned char G_p[8] = { 
	0x00, 
	0x7C, 
	0x84, 
	0x84, 
	0xFC, 
	0x80, 
	0x80, 
	0x80};


const unsigned char G_q[8] = { 
	0x00, 
	0x7C, 
	0x84, 
	0x84, 
	0xFC, 
	0x04, 
	0x04, 
	0x04};


const unsigned char G_r[8] = { 
	0x00, 
	0x00, 
	0x00, 
	0x3C, 
	0x40, 
	0x40, 
	0x40, 
	0x00};


const unsigned char G_s[8] = { 
	0x00, 
	0x00, 
	0x3C, 
	0x40, 
	0x38, 
	0x04, 
	0x7C, 
	0x00};


const unsigned char G_t[8] = { 
	0x20, 
	0x20, 
	0x7C, 
	0x20, 
	0x20, 
	0x20, 
	0x3C, 
	0x00};


const unsigned char G_u[8] = { 
	0x00, 
	0x00, 
	0x00, 
	0x84, 
	0x84, 
	0x84, 
	0x7C, 
	0x00};


const unsigned char G_v[8] = { 
	0x00, 
	0x00, 
	0x00, 
	0x82, 
	0xC6, 
	0x6C, 
	0x38, 
	0x00};


const unsigned char G_w[8] = { 
	0x00, 
	0x00, 
	0x00, 
	0x92, 
	0x92, 
	0x92, 
	0x7E, 
	0x00};


const unsigned char G_x[8] = { 
	0x00, 
	0x00, 
	0x84, 
	0x48, 
	0x30, 
	0x48, 
	0x84, 
	0x00};


const unsigned char G_y[8] = { 
	0x00, 
	0x84, 
	0x84, 
	0x84, 
	0x7C, 
	0x04, 
	0x84, 
	0x7C};


const unsigned char G_z[8] = { 
	0x00, 
	0x00, 
	0x3C, 
	0x04, 
	0x38, 
	0x40, 
	0x7C, 
	0x00};


const unsigned char G_ny[8] = { 
	0x00, 
	0x3C, 
	0x00, 
	0x3C, 
	0x44, 
	0x44, 
	0x44, 
	0x00};


const unsigned char G_at[8] = { 
	0x01, 
	0x02, 
	0x78, 
	0x04, 
	0x7C, 
	0x84, 
	0x7C, 
	0x00};


const unsigned char G_et[8] = { 
	0x01, 
	0x02, 
	0x78, 
	0x84, 
	0xF8, 
	0x80, 
	0x7C, 
	0x00};


const unsigned char G_it[8] = { 
	0x08, 
	0x10, 
	0x00, 
	0x10, 
	0x10, 
	0x10, 
	0x10, 
	0x00};


const unsigned char G_ot[8] = { 
	0x01, 
	0x02, 
	0x78, 
	0x84, 
	0x84, 
	0x84, 
	0x78, 
	0x00};


const unsigned char G_ut[8] = { 
	0x08, 
	0x10, 
	0x00, 
	0x84, 
	0x84, 
	0x84, 
	0x7C, 
	0x00};


const unsigned char G_pt[8] = { 
	0x00, 
	0x00, 
	0x00, 
	0x00, 
	0x00, 
	0x60, 
	0x60, 
	0x00};


const unsigned char G_cm[8] = { 
	0x00, 
	0x00, 
	0x00, 
	0x00, 
	0x00, 
	0x20, 
	0x40, 
	0x00};


const unsigned char G_str[8] = { 
	0x00, 
	0x00, 
	0x70, 
	0x1C, 
	0x0E, 
	0x1C, 
	0x70, 
	0x00};


const unsigned char G_bl[8] = { 
	0x00, 
	0x00, 
	0x00, 
	0x00, 
	0x00, 
	0x00, 
	0x00, 
	0x00};


const unsigned char G_piz[8] = { 
	0x00, 
	0x0C, 
	0x18, 
	0x30, 
	0x30, 
	0x18, 
	0x0C, 
	0x00};


const unsigned char G_pdr[8] = { 
	0x00, 
	0x30, 
	0x18, 
	0x0C, 
	0x0C, 
	0x18, 
	0x30, 
	0x00};


const unsigned char G_lv[8] = { 
	0x10, 
	0x28, 
	0x28, 
	0x54, 
	0x44, 
	0x82, 
	0xFE, 
	0x00};

const unsigned char G_ful[8] = { 
	0x00, 
	0xFF, 
	0xFF, 
	0xFF, 
	0xFF, 
	0xFF, 
	0xFF, 
	0xFF};

const unsigned char G_ap[8] = { 
	0x00, 
	0x00, 
	0x18, 
	0x08, 
	0x00, 
	0x00, 
	0x00, 
	0x00};

const unsigned char G_exc[8] = { 
	0x10, 
	0x10, 
	0x10, 
	0x10, 
	0x10, 
	0x00, 
	0x10, 
	0x00};
		
const unsigned char G_eol[1] = { 
	0xFF};	