//Sistema personalizado para pintar caracteres de forma personalizada, puede tener hasta 255 caracteres
//reservándose el último (valor 255) para una marca especial de fin de línea.
//Se crean líneas que luego serán pintadas por myDrawString, para ello le pasaremos un array de bytes.
//
//Cada carácter es un sprite de 1Bytex8pixels, y la primera fila nunca puede ser 0xFF
//
//f_c será un puntero para indicar dónde empezar a pintar la línea, se irá actualizando automáticamente al llamar a myDrawString
//por lo que si son líneas seguidas, no es necesario reasignar para las siguientes líneas.
//
//f_teletipo es un booleano para que el texto se vaya pintando poco a poco (valor = 1), si se pulsa tecla, pasará a valor 0 y 
//se escribirá el resto del texto sin más pausa.
//
//Por ejemplo el siguiente texto se codificaría así
//> Año 2070.
//txt[12] = { 44, 45, 10, 36, 24, 45, 2, 0, 7, 0, 42, 255};

//Macros
#define MAX_CHARS_PER_LINE 80

extern unsigned char f_teletipo;
extern unsigned char *f_c; 
void myDrawString (unsigned char* f_l) ;

extern const unsigned char G_S0[8]; //00
extern const unsigned char G_S1[8]; //01
extern const unsigned char G_S2[8];	//02
extern const unsigned char G_S3[8];	//03
extern const unsigned char G_S4[8];	//04
extern const unsigned char G_S5[8];	//05
extern const unsigned char G_S6[8];	//06
extern const unsigned char G_S7[8];	//07
extern const unsigned char G_S8[8];	//08
extern const unsigned char G_S9[8];	//09
extern const unsigned char G_a[8];	//10
extern const unsigned char G_b[8];	//11
extern const unsigned char G_c[8];	//12
extern const unsigned char G_d[8];	//13
extern const unsigned char G_e[8];	//14
extern const unsigned char G_f[8];	//15
extern const unsigned char G_g[8];	//16
extern const unsigned char G_h[8];	//17
extern const unsigned char G_i[8];	//18
extern const unsigned char G_j[8];	//19
extern const unsigned char G_k[8];	//20
extern const unsigned char G_l[8];	//21
extern const unsigned char G_m[8];	//22
extern const unsigned char G_n[8];	//23
extern const unsigned char G_o[8];	//24
extern const unsigned char G_p[8];	//25
extern const unsigned char G_q[8];	//26
extern const unsigned char G_r[8];	//27
extern const unsigned char G_s[8];	//28
extern const unsigned char G_t[8];	//29
extern const unsigned char G_u[8];	//30
extern const unsigned char G_v[8];	//31
extern const unsigned char G_w[8];	//32
extern const unsigned char G_x[8];	//33
extern const unsigned char G_y[8];	//34
extern const unsigned char G_z[8];	//35
extern const unsigned char G_ny[8];	//36
extern const unsigned char G_at[8];	//37
extern const unsigned char G_et[8];	//38
extern const unsigned char G_it[8];	//39
extern const unsigned char G_ot[8];	//40
extern const unsigned char G_ut[8];	//41
extern const unsigned char G_pt[8];	//42
extern const unsigned char G_cm[8];	//43
extern const unsigned char G_str[8];//44
extern const unsigned char G_bl[8];	//45
extern const unsigned char G_piz[8];//46
extern const unsigned char G_pdr[8];//47
extern const unsigned char G_lv[8];	//48
extern const unsigned char G_ful[8];//49
extern const unsigned char G_ap[8];	//50
extern const unsigned char G_exc[8];//51
//Caracter especial para indicar final de línea y no tener que crear un array de MAX_CHARS_PER_LINE. Contiene 0xFF, por lo que ningún sprite de fuente
//puede ser FF en su primera línea
extern const unsigned char G_eol[1];//255