#include <cpctelera.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include "main.h"
#include "consola.h"
#include "funciones.h"
#include "graficos/Sprites_rgas.h"

u8 contador = 0;

void pausaTecladoLibre(){
	while (cpct_isAnyKeyPressed_f ()) { //Asegurarnos que se ha dejado de pulsar la tecla anterior (seleccionar idioma)
   		cpct_scanKeyboard_f();
   	}
}

u8 tecladoPulsado(){
	cpct_scanKeyboard_f();
   	if ( cpct_isAnyKeyPressed_f ())
	   	return 1;
   	else
   		return 0;
}

u8 maximo (u8 punto1, u8 punto2) {
  return (punto1 > punto2 ? punto1 : punto2);
}

u8 minimo (u8 punto1, u8 punto2) {
	return (punto1 < punto2 ? punto1 : punto2);
}

u8 recortar (u8 valor, u8 tipo, u8 limite){
	if (tipo == MENOR_QUE && valor < limite)
		return limite;
	else if (tipo == MAYOR_QUE && valor > limite)
		return limite;
	else 
		return valor;
}

u8 pressedUp() {
	if (cpct_isKeyPressed(Key_Q) || cpct_isKeyPressed(Key_CursorUp) || cpct_isKeyPressed(Joy0_Up))
		return 1;
	else 
		return 0;
}

u8 pressedDown() {
	if (cpct_isKeyPressed(Key_A) || cpct_isKeyPressed(Key_CursorDown) || cpct_isKeyPressed(Joy0_Down))
		return 1;
	else 
		return 0;
}

u8 pressedLeft() {
	if (cpct_isKeyPressed(Key_O) || cpct_isKeyPressed(Key_CursorLeft) || cpct_isKeyPressed(Joy0_Left))
		return 1;
	else 
		return 0;
}

u8 pressedRight() {
	if (cpct_isKeyPressed(Key_P) || cpct_isKeyPressed(Key_CursorRight) || cpct_isKeyPressed(Joy0_Right))
		return 1;
	else 
		return 0;
}

u8 pressedFire() {
	if (cpct_isKeyPressed(Key_Space) || cpct_isKeyPressed(Joy0_Fire1))
		return 1;
	else 
		return 0;
}
u8 pressedChangeView(){
	if (cpct_isKeyPressed(Key_S) || cpct_isKeyPressed(Joy0_Fire2))
		return 1;
	else 
		return 0;
}

void accionesTeclado(){
	u8 i;
	u32 timestop;

	cpct_scanKeyboard_f();
   	if (cpct_isAnyKeyPressed) {
   		if (cpct_isKeyPressed(Key_1)) { // Música
   			pausaTecladoLibre();
   			musica = ~musica;
   			cpct_akp_stop();
   		}
   		if (cpct_isKeyPressed(Key_3)) { // Pausa
   			pausaTecladoLibre();
   			timestop = speedrun; //Para que no corra el contador de tiempo durante la pausa

   			cpct_akp_stop();
   			i = musica; // Para luego dejar la música como estaba on/off
   			musica = 1; 
   			borrarAreaJuego();
   			txtMedPausa();
			cpct_drawSpriteBlended(cpct_getScreenPtr(CPCT_VMEM_START, 29, 80),40,22,G_Logo);

   			while (!cpct_isKeyPressed(Key_3)){
   				cpct_scanKeyboard_f();
   			}
   			pausaTecladoLibre();

   			borrarAreaJuego();
   			if (nivel == 3)
   				backgroundFase3();
   			musica = i;
   			speedrun = timestop;
   		}
   		if (cpct_isKeyPressed(Key_5)) { // Game Over
   			cheat = 0; //Quitar modo cheat
   			vidas = 0;
   		}
		if (pressedLeft() || pressedRight() || pressedUp() || pressedDown()) 
			moverNave(0);
	   	if (pressedFire())
	   		laser.temp = 1;
	   	if (!pressedChangeView() )
	   		vista_pulsada = 0;
	   	if (pressedChangeView() && !vista_pulsada && nivel != 6) {
	   			cambiarVista();
		   		
		   		if (nivel == 3)
		   			if (vista == HORIZONTAL) // Ya está cambiado el valor vista
		   				initParedHorizontal();
		   			else // Vertical
		   				initParedVertical();
		   			
		   		pintarNave();
				vista_pulsada = 1;
	   	}
	}
}


u8 RandomX(){
	return cpct_rand() % 80;
}

u8 RandomY(u8 clip){
	// Dejar márgenes con los bordes para que no se mezclen explosiones con el marco y no estén en lugares inaccesibles para la nave
	return AREA_JUEGO_SUPERIOR_VAR + (clip/9) + (cpct_rand()%(AREA_JUEGO_INFERIOR-AREA_JUEGO_SUPERIOR_VAR-clip));
}

u8 hayColision(TObjeto *o1, TObjeto *o2){
	u8 j,k;

	u8 max_x0,min_x1,max_y0,min_y1;
	u8 rec_x0,rec_x1,rec_y0,rec_y1;
	u8 byte_o1;
	u8 byte_o2;
	//Ver si los rectángulos que forman ambos objetos colisionan
	max_x0 = maximo (o1->x, o2->x);
	min_x1 = minimo (o1->x + o1->ancho, o2->x + o2->ancho);
	max_y0 = maximo (o1->y, o2->y);
	min_y1 = minimo (o1->y + o1->alto,  o2->y + o2->alto);
	if (max_x0 <= min_x1 && max_y0 < min_y1) {
		//comprobar si hay colisión a nivel de pixel en el recuadro de intersección que estará definido por
		// (minimo (max_x0,min_x1) , minimo (max_y0,min_y1) ) y
		// (maximo (max_x0,min_x1) , maximo (max_y0,min_y1) )
		rec_x0 = minimo (max_x0,min_x1);
		rec_x1 = maximo (max_x0,min_x1);
		rec_y0 = minimo (max_y0,min_y1);
		rec_y1 = maximo (max_y0,min_y1);

		// En el recuadro de intersección, ir byte por byte. Recuperar el valor del gráfico de cada objeto
		// y hacer un AND. Si el resultado es distinto de 0 es porque en esa posición ambos tienen pixel => Colisión
		j = rec_y0;
		while (j < rec_y1){
			k = rec_x0;
			while (k < rec_x1){
				byte_o1 = o1->sprite[ (((j - o1->y) * o1->ancho) + (k - o1->x)) ];
				byte_o2 = o2->sprite[ (((j - o2->y) * o2->ancho) + (k - o2->x)) ];
				if ((byte_o1 & byte_o2) != 0){ // Hacemos un AND de ambos bytes, si es distinto de 0 es porque han coincidido pixels					
					return 1;
					}
				k++;
				}
			j++;
		}

	}
	// No se ha encontrado colisión
	return 0;
}

u8 hayColisionDisparo(TObjeto *o, TDisparo *d){
	TObjeto dummy;

//Convertir disparo en TObjeto y reutilizar hayColision
	dummy.x = d->x_ant;
	dummy.ancho = 1;
	dummy.y = d->y_ant;
	dummy.alto = 4;
	dummy.sprite = &disparo_sprite[0];
	return hayColision(o, &dummy);
}

void colisiones(){
	i8 diferencia = 0;
	u8 i;

	for (i=1;i<total_elementos;i++){
		if (objetos[i].temp < 10) {
			//Disparos contra Nave
			if (objetos[0].temp == 0 && disparos[i].x != 0 && disparos[i].y != 0 && hayColisionDisparo(&objetos[0], &disparos[i])) { 
					muerteObjeto(&objetos[0]);
					aprendizajeInsector(&objetos[i], +1);
					disparos[i].x = disparos[i].y = 0; //Resetear disparo
				}
			diferencia = objetos[i].z - objetos[0].z; // diferencia entre asteroide y nave en Dimensión no proyectada
			if (diferencia >= -MARGEN_PLANO && diferencia <= MARGEN_PLANO){ 	// Están en el mismo plano	
				//Disparo contra enemigos
				if (hayColision(&laser, &objetos[i])) {
					if (objetos[i].tipo == 1) 
						muerteObjeto(&objetos[i]);
					else if (objetos[i].tipo == 2) {
						muerteObjeto(&objetos[i]);
					}
				}
				
				//Nave choca contra enemigos
				if (objetos[0].temp == 0 && hayColision(&objetos[0], &objetos[i])) { 
					muerteObjeto(&objetos[0]);
					if (objetos[i].tipo == 2) {
						aprendizajeInsector(&objetos[i], +1);
						objetos[i].temp = 2;//estrategia de alejarse para impedir muerte inminente al reaparecer la nave
					}
				}
			}
		}
	}

	if (nivel == 6) { //Tratamiento especial para nave nodriza
		if (laser.temp == 1 && laser.x > (u8) (timeline / 16) && laser.x < (u8) (timeline / 16) + 48 && laser.y < 20) {
			enemigos--; //quitarle un punto de energía si el laser está entre la x de la nodriza y su longitud, y la nave a menos de 8 pixels
			laser.z = 1; // Para que sólo cuente un disparo
			cpct_akp_SFXPlay (2, VOLUMEN_EXPLOSION, 36, 0, 0, AY_CHANNEL_B);
			pintarEnergiaNodriza();
		}
	}
}
void muerteObjeto(TObjeto *o){

	if (o->tipo == 1){ //Asteroide
		puntuacion = puntuacion + 1;
	} else if (o->tipo == 2){ //Insector
		puntuacion = puntuacion + 3;
		//Puntuar negativamente la estrategia que estaba usando
		aprendizajeInsector(o, -1); 
	} 

	//explosión y marcar enemigo para que no se dibuje más
	o->temp = 10; //temp == 10 es una marca especial para indicar que debe empezar la animación de la explosión
	
	if (o->tipo == 0) {	//Al morir nave, borrar área de juego y repintar enemigos, pues al resetar Z, puede ser que ya no estén a la misma profundidad antes de la muerte y tras el respawn
		while (o->temp < 128) {
			debug_buddy(o->temp,0);
			explosion(o);
		}

		borrarAreaJuego();
		if (nivel != 3) { //En Nivel 3 (túnel) no hay que restablecer vista ni posición
			if (vista == HORIZONTAL) 
				cambiarVista();

			posicionInicialNave();
			pintarNave();
		} else {
			backgroundFase3();
		}
	}

	txtInfMarcador(); //Actualizar marcador (puntos o vidas)
}

void estrategiaInsector(TObjeto *o){
	i8 dummy;
	u8 i;
	u8 proporcion[MAX_ESTRATEGIAS];
	u16 papeletas, dummy2; //escogeremos la siguiente estrategia de manera aleatoria, pero las que estén funcionando mejor tendrán más posibilidades

	if (o->temp == 0) { //Cada 6 segs aproximadamente gestionEnemigos vuelve a poner temp a 0
		//Cambiar o iniciar estrategia, 1: Acercarse a Nave; 2: Alejarse de Nave; 3: Acercarse a compañeros; 4: Nada
		//Según aprendizaje anterior, dará más posibilidades a la estrategia que ha funcionado mejor "IA"
		
		dummy = 127; //servirá para obtener el valor de la peor estrategia hasta ahora
		i = MAX_ESTRATEGIAS;
		do{
			--i;
			if (estrategias[i] < dummy)
				dummy = estrategias[i];
		} while (i);

		//Proporcion de las estrategias teniendo como referencia la menor
		i = MAX_ESTRATEGIAS;
		papeletas = 0;
		do{
			--i;
			proporcion[i]=estrategias[i] - dummy + 1; //la mínima estrategia también tendrá una "papeleta" (aunque remota). El resto la diferencia con este mínimo + 1
			papeletas += proporcion[i]; //calculamos el total de papeletas a sortear
		} while (i);

		papeletas = cpct_rand() % papeletas; //Cogemos una "papeleta" de las posibles al azar. Reutilizamos variable

		i = MAX_ESTRATEGIAS;
		dummy = -1; //Marca para indicar que todavía no se ha encontrado la papeleta "ganadora"
		dummy2 = 0; //llevar la cuenta de las papeletas ya revisadas
		do{
			--i;
			if (dummy2 + proporcion[i] > papeletas )
				dummy = i; //es la estrategia seleccionada
			else
				dummy2 += proporcion[i];			
		} while (i && dummy < 0);

		o->temp = dummy + 1;
	}

	dummy = 1;
	//temp no servirá para confirmar que se usará la estrategia escogida

	if (o->temp == 1 && cpct_rand() % 3){ // Acercarse, sólo el 66% de las veces, para no ser tan pegajoso
		if (objetos[0].x > (o->x)) 	o->x++;
		if (objetos[0].x < (o->x) && o->x > 0)	o->x--;
		if (objetos[0].y > (o->y))	o->y++;
		if (objetos[0].y < (o->y) && o->y > 0)	o->y--;
		if (objetos[0].z > (o->z)) 	o->z++;
		if (objetos[0].z < (o->z) && o->z > 0)	o->z--;
	}
	

	if (o->temp == 2){ // Alejarse
		if (objetos[0].x > (o->x) && o->x > 0)	o->x--;
		if (objetos[0].x < (o->x))	o->x++;
		if (objetos[0].y > (o->y) && o->y > 0)	o->y--;
		if (objetos[0].y < (o->y))	o->y++;
		if (objetos[0].z > (o->z) && o->z > 0)	o->z--;
		if (objetos[0].z < (o->z))	o->z++;	
	}
	if (o->temp == 3){ // Agruparse
		dummy = 0; //Para saber si encontró compañero. Si no encuentra usar otra estrategia
		for (i = 1; i< MAX_ELEMENTOS; i++){
			//Buscar un compañero activo que no sea él mismo y esté en otra posición
			if (objetos[i].temp < 10 && objetos[i].tipo == 2 && objetos[i].x != o->x && objetos[i].y != o->y && objetos[i].z != o->z) { 
				dummy = 1;
				if (objetos[i].x > (o->x)) 	o->x++;
				if (objetos[i].x < (o->x) && o->x > 0)	o->x--;
				if (objetos[i].y > (o->y))	o->y++;
				if (objetos[i].y < (o->y) && o->y > 0)	o->y--;
				if (objetos[i].z > (o->z))	o->z++;
				if (objetos[i].z < (o->z) && o->z > 0)	o->z--;
				break; //Sólo lo hacemos para el primer compañero que encuentre
			} 
		}
	}
	if (o->temp == 4){ 
		// Nada, no moverse	
		//Aleatorio
		//o->x = o->x + cpct_rand()%2 - 1; 
		//o->y = o->y + cpct_rand()%2 - 1; 
		//o->z = o->z + cpct_rand()%2 - 1; 
	}

	o->x = recortar (o->x, MAYOR_QUE, ANCHO_PANTALLA - 1 - o->ancho);
	o->x = recortar (o->x, MENOR_QUE, 5);
	o->y = recortar (o->y, MAYOR_QUE, AREA_JUEGO_INFERIOR - 15 - o->alto); //Que no puedan bajar del todo para que se les pueda matar más fácil
	o->y = recortar (o->y, MENOR_QUE, AREA_JUEGO_SUPERIOR_VAR + 1);
	o->z = recortar (o->z, MAYOR_QUE, AREA_JUEGO_INFERIOR - 15 - o->alto_otro); //Que no puedan bajar del todo para que se les pueda matar más fácil
	o->z = recortar (o->z, MENOR_QUE, AREA_JUEGO_SUPERIOR_VAR + 1);	

	if (dummy == 0)
		o->temp = 0; //la estrategia que salió escogida no se ha podido concretar. Seleccionar otra
}

void aprendizajeInsector(TObjeto *o, i8 signo) {
	//signo será +1 o -1 según haya matado a la nave o haya muerto él
	if (o->temp && o->temp <= MAX_ESTRATEGIAS && estrategias[o->temp-1] > -127 && estrategias[o->temp-1] < 127) //Actualizar tabla de estrategias hasta límite de i8
		estrategias[o->temp-1] += signo;
}

void backgroundFase3(){
	if (vista == VERTICAL){
		cpct_drawSolidBox (cpct_getScreenPtr(CPCT_VMEM_START,  0, AREA_JUEGO_SUPERIOR_INI), 0XFF, 35, AREA_JUEGO_INFERIOR - AREA_JUEGO_SUPERIOR_INI + 1);
		//cpct_drawSolidBox (cpct_getScreenPtr(CPCT_VMEM_START,  0, AREA_JUEGO_SUPERIOR_INI), 0XFF, ParedA.x, AREA_JUEGO_INFERIOR - AREA_JUEGO_SUPERIOR_INI + 1);
		cpct_drawSolidBox (cpct_getScreenPtr(CPCT_VMEM_START,  43, AREA_JUEGO_SUPERIOR_INI), 0XFF, ANCHO_PANTALLA - 43, AREA_JUEGO_INFERIOR - AREA_JUEGO_SUPERIOR_INI + 1);
		//cpct_drawSolidBox (cpct_getScreenPtr(CPCT_VMEM_START,  ParedB.x + ParedB.ancho, AREA_JUEGO_SUPERIOR_INI), 0XFF, ANCHO_PANTALLA - ParedB.x - ParedB.ancho, AREA_JUEGO_INFERIOR - AREA_JUEGO_SUPERIOR_INI + 1);
		cpct_drawSolidBox (cpct_getScreenPtr(CPCT_VMEM_START,  35, AREA_JUEGO_SUPERIOR_INI), 0XFF, 2, LIMITE_NIVEL3 - AREA_JUEGO_SUPERIOR_INI + 1);
		//cpct_drawSolidBox (cpct_getScreenPtr(CPCT_VMEM_START,  ParedA.x, AREA_JUEGO_SUPERIOR_INI), 0XFF, ParedA.ancho, LIMITE_NIVEL3 - AREA_JUEGO_SUPERIOR_INI + 1);
		cpct_drawSolidBox (cpct_getScreenPtr(CPCT_VMEM_START,  41, AREA_JUEGO_SUPERIOR_INI), 0XFF, 2, LIMITE_NIVEL3 - AREA_JUEGO_SUPERIOR_INI + 1);
		//cpct_drawSolidBox (cpct_getScreenPtr(CPCT_VMEM_START,  ParedB.x, AREA_JUEGO_SUPERIOR_INI), 0XFF, ParedB.ancho, LIMITE_NIVEL3 - AREA_JUEGO_SUPERIOR_INI + 1);
	} else {
		cpct_drawSolidBox (cpct_getScreenPtr(CPCT_VMEM_START,  0, AREA_JUEGO_SUPERIOR_INI), 0XFF, 40, 101 - AREA_JUEGO_SUPERIOR_INI);
		//cpct_drawSolidBox (cpct_getScreenPtr(CPCT_VMEM_START,  0, AREA_JUEGO_SUPERIOR_INI), 0XFF, 40, ParedA.y - AREA_JUEGO_SUPERIOR_INI);
		cpct_drawSolidBox (cpct_getScreenPtr(CPCT_VMEM_START, 40, AREA_JUEGO_SUPERIOR_INI), 0XFF, 40, 101 - AREA_JUEGO_SUPERIOR_INI);
		//cpct_drawSolidBox (cpct_getScreenPtr(CPCT_VMEM_START, 40, AREA_JUEGO_SUPERIOR_INI), 0XFF, 40, ParedA.y - AREA_JUEGO_SUPERIOR_INI);
		cpct_drawSolidBox (cpct_getScreenPtr(CPCT_VMEM_START,  0, 119), 0XFF, 40, AREA_JUEGO_INFERIOR - 119 + 1);
		//cpct_drawSolidBox (cpct_getScreenPtr(CPCT_VMEM_START,  0, ParedB.y), 0XFF, 40, AREA_JUEGO_INFERIOR - ParedB.y + 1);
		cpct_drawSolidBox (cpct_getScreenPtr(CPCT_VMEM_START, 40, 119), 0XFF, 40, AREA_JUEGO_INFERIOR - 119 + 1);
		//cpct_drawSolidBox (cpct_getScreenPtr(CPCT_VMEM_START, 40, ParedB.y), 0XFF, 40, AREA_JUEGO_INFERIOR - ParedB.y + 1);
	}
}

void borrarAreaJuego(){
	cpct_drawSolidBox (cpct_getScreenPtr(CPCT_VMEM_START,  0, AREA_JUEGO_SUPERIOR_VAR), 0, 40, AREA_JUEGO_INFERIOR + 1 - AREA_JUEGO_SUPERIOR_VAR);
	cpct_drawSolidBox (cpct_getScreenPtr(CPCT_VMEM_START, 40, AREA_JUEGO_SUPERIOR_VAR), 0, 40, AREA_JUEGO_INFERIOR + 1 - AREA_JUEGO_SUPERIOR_VAR);
}

void invulnerabilidad(){
	    if (objetos[0].temp % 2)  //Para dibujar intermitente el borde
	      cpct_setBorder(HW_WHITE);
	    else
	      cpct_setBorder(HW_BLACK);

	  	if (objetos[0].temp < 180) //Duración de la invulnerabilidad
	    	objetos[0].temp++;  
	   	else
	   		objetos[0].temp=0;
}

void pintarNave(){
	if (vidas  || !nivel) //En el tutorial, no hay vidas aún
		cpct_drawSpriteBlended (cpct_getScreenPtr(CPCT_VMEM_START, (objetos[0].x + objetos[0].offset), objetos[0].y), objetos[0].alto , objetos[0].ancho, objetos[0].sprite);  
}


void initLaser(){
	laser.x = laser.y = 0;
	laser.z = TIMEOUT_DISPARO; // En atributo z guardo el tiempo que debe estar visible el disparo
	laser.alto = laser.ancho = 0;
	laser.temp = 0;
}

void updateObjetosCambioVista(){
	const u8* sprite_t;
	u8 alto_t, ancho_t;
	int offset_t;
	TObjeto *o;
	u8 i;

	o = objetos + (total_elementos - 1);
	//Ejemplo optimización estructuras en bucle usando punteros
	//ahorra memoria y ejecuta menos pasos, que puede venir bien en
	//este proc que se usa cada vez que se cambia de vista
	//También optimización de usar bucles decrementales para comparar con Cero en vez de otro valor
	i = total_elementos + 1;
	while (--i) {
		sprite_t = o->sprite;
		alto_t = o-> alto;
		ancho_t = o-> ancho;
		offset_t = o-> offset;

		o->sprite = o->sprite_otro;
		o->sprite_otro = sprite_t;
		o->alto = o->alto_otro;
		o->alto_otro = alto_t;
		o->ancho = o->ancho_otro;
		o->ancho_otro = ancho_t;
		o->offset = o->offset_otro;
		o->offset_otro = offset_t;
		--o;		
	}
}

void cambiarVista(){
	i16 x1,y1,z1;
	u8 i;
	
		borrarAreaJuego();
	
		//Resetear laser
		initLaser();

		for (i=0;i<total_elementos;i++) {
			if (vista == VERTICAL) {
				z1=objetos[i].x;
				if ((objetos[i].alto + objetos[i].y) > AREA_JUEGO_INFERIOR)
					x1 = 0;
				else
					x1=(AREA_JUEGO_INFERIOR - objetos[i].alto - objetos[i].y) / factor_vista;

				y1=objetos[i].z;
			} else { //HORIZONTAL
				if ((factor_vista * objetos[i].x) > (AREA_JUEGO_INFERIOR - objetos[i].alto))
					y1 = AREA_JUEGO_SUPERIOR_VAR;
				else
					y1=(AREA_JUEGO_INFERIOR - objetos[i].alto) - (factor_vista * objetos[i].x);

				z1=objetos[i].y;
				x1=objetos[i].z;
			}

			//comprobaciones por si hay "overflow", tener en cuenta dimensiones de la otra vista
			if (x1 < 0 ){
				objetos[i].x = 0;
			}
			
			objetos[i].x = recortar ((u8) x1, MAYOR_QUE, ANCHO_PANTALLA - 1 - objetos[i].ancho_otro);
			
			objetos[i].y = recortar ((u8) y1, MENOR_QUE, AREA_JUEGO_SUPERIOR_VAR);
			objetos[i].y = recortar ((u8) y1, MAYOR_QUE, AREA_JUEGO_INFERIOR - objetos[i].alto_otro);

			objetos[i].z = z1;

			if (disparos[i].y){
				//Estaba disparando en el cambio de vista y hay que llevarlo 
				disparos[i].x = recortar((disparos[i].y - AREA_JUEGO_SUPERIOR_VAR) / factor_vista, MAYOR_QUE, ANCHO_PANTALLA - 1);
				disparos[i].y = recortar(AREA_JUEGO_SUPERIOR_VAR + (factor_vista * disparos[i].x), MAYOR_QUE,AREA_JUEGO_INFERIOR);

				x1 = disparos[i].x_factor;
				if (vista == VERTICAL) {
					disparos[i].x_factor = disparos[i].y_factor * -1;
					disparos[i].y_factor = x1;
				} else {
					disparos[i].x_factor = disparos[i].y_factor;
					disparos[i].y_factor = x1 * -1;
				}
			}
		}
		if (vista == VERTICAL)
			vista = HORIZONTAL;
		else
			vista = VERTICAL;

		updateObjetosCambioVista();
} 

void posicionInicialNave(){
	//*** Usar template y cpct_memcpy
	cpct_memcpy (&objetos[0],&NaveValoresIniciales,sizeof(TObjeto));
	if (nivel > 3) { //Para fases 4,5 y 6 se usa los otros sprites de la nave
		objetos[0].sprite = &G_NaveBatallaV2[0];
		objetos[0].sprite_otro = &G_NaveBatallaH2[0];
	}
}

void esAsteroide(TObjeto *o){
	o->tipo = 1;
	o->sprite = &G_Asteroide_m[0]; 
	o->sprite_otro = &G_Asteroide_m[0];
	o->alto = o->alto_otro = 16;
	o->ancho = o->ancho_otro = 4;
}

void esInsector(TObjeto *o){
	o->tipo = 2;
	o->sprite = &G_Insector_V2_f0[0]; 
	//o->sprite_otro = &G_Insector_H2_f0[0];
	o->alto = 20;
	o->alto_otro = 16;
	o->ancho = 4;
	o->ancho_otro = 6;
}

void initObjetos(){
	u8 i;

	vista = VERTICAL;
	initLaser();

	posicionInicialNave();

	//Posición enemigos
	for (i=1;i<total_elementos;i++){
		if (nivel < 6) {
			objetos[i].x = RandomX();
			objetos[i].y = RandomY(45);
			objetos[i].z = RandomY(45);
		} else { //Fila de naves Nivel 6
			objetos[i].x = cpct_rand() % 10;
			objetos[i].y = 42 + (i-1)*44;
			objetos[i].z = objetos[0].z;
			objetos[i].tipo = 3;
			objetos[i].sprite = &G_Naves[0]; 
			objetos[i].alto = 8;
			objetos[i].ancho = 69;
			}
		switch (nivel){ //asignar tipo a cada enemigo por nivel (por defecto)
			case 1:esAsteroide(&objetos[i]);
				break;
			case 2:esInsector(&objetos[i]);
				break;
			case 4:esInsector(&objetos[i]);
				break;
			case 5:esInsector(&objetos[i]);
				break;
			}
		objetos[i].offset = objetos[i].offset_otro = 0;
		objetos[i].temp = 0;
		disparos[i].x = disparos[i].y = 0;
	}

	for (i=total_elementos;i<MAX_ELEMENTOS;i++){
		objetos[i].temp = 128; // El resto de la tabla de objetos se marcan como no activos
	}
	//Se hace doble cambio de vista por si algún enemigo ha quedado fuera de margen por el Random
	if (nivel < 6) {
		cambiarVista();
		cambiarVista();
	}
}

void initParedHorizontal(){
	ParedA.x = ParedB.x = 0;
	ParedA.y = 101; ParedB.y = 119;
	ParedA.ancho = ParedB.ancho = ANCHO_PANTALLA/2; //No es posible pintar los 80 bytes, se divide
	ParedA.alto = ParedB.alto = 2;
	ParedA.offset = ParedB.offset = 2;
	ParedA.offset_otro = ParedB.offset_otro = 2;
	ParedA.sprite = &paredArr1[0];
	ParedB.sprite = &paredAba1[0];
	backgroundFase3();
}

void initParedVertical(){
	ParedA.x = 35; ParedB.x = 41;
	ParedA.y = ParedB.y = LIMITE_NIVEL3 + 1;
	ParedA.ancho = ParedB.ancho = 2;
	ParedA.alto = ParedB.alto = AREA_JUEGO_INFERIOR - LIMITE_NIVEL3;
	ParedA.sprite = &paredIzq[0];
	ParedB.sprite = &paredDer[0];
	ParedA.offset = ParedB.offset = 2;
	ParedA.offset_otro = ParedB.offset_otro = 2;
	backgroundFase3();
}

void oleadas(){
	u8 i;
	i = 0;
	
	if (nivel == 2) {
		if (enemigos == 7) //Segunda oleada: 2 Enemigos sin disparo
			total_elementos = i = 3; //Pongo a i distinto de 0 para saber si ejecutar reset enemigos, nueva oleada
		else if (enemigos == 5) //Tercera oleada: 1 Enemigos con disparo
			total_elementos = i = 2;
		else if (enemigos == 4) //Cuarta oleada: 2 Enemigos con disparo
			total_elementos = i = 3;
		else if (enemigos == 2) //Quinta oleada: 2 Enemigos con disparo
			total_elementos = i = 3;
		}

	if (nivel == 4) {
		if (enemigos == 6) //Segunda oleada: 1 enemigo con disparo
			total_elementos = i = 2; //Pongo a i distinto de 0 para saber si ejecutar reset enemigos, nueva oleada
		else if (enemigos == 5) //Tercera oleada: 1 Enemigo con disparo
			total_elementos = i = 2;
		else if (enemigos == 4) //Cuarta oleada: 2 Enemigos con disparo
			total_elementos = i = 3;
		else if (enemigos == 2) //Quinta oleada: 2 Enemigos con disparo
			total_elementos = i = 3;
		}

	if (nivel == 5) {
		if (enemigos == 6) //Segunda oleada: 2 enemigo con disparo
			total_elementos = i = 3; //Pongo a i distinto de 0 para saber si ejecutar reset enemigos, nueva oleada
		else if (enemigos == 4) //Tercera oleada: 2 Enemigo con disparo
			total_elementos = i = 3;
		else if (enemigos == 2) //Cuarta oleada: 2 Enemigos con disparo
			total_elementos = i = 3;
		}

	if (i)
		initObjetos();
	}

void gestionEnemigos(){
	//Asteroides
	i8 diferencia = 0;
	u8 i, temp_x, temp_y, temp_ancho, temp_alto;
	const u8 *temp_sprite;

	
	cpct_waitVSYNC();
	for (i=1;i<total_elementos;i++){
		if (objetos[i].temp < 10) { // Sólo revisar los activos
			temp_x = temp_y = temp_ancho = temp_alto = 0; 
			temp_sprite = NULL;
			if (objetos[i].tipo > 1) {//Tipo 2:insector; 3: Naves
						// Si es enemigo dinámico hay que calcular siguiente posición y marcar para que borre anterior (!temp_alto)
						//Lo dejo en variables temporales para que se pueda hacer el borrado y el pintado de manera casi inmediata y evitar flickering
						//pues el procedimiento de averiguar siguiente posición lleva cálculo por la "IA" programada
						temp_x = objetos[i].x;
						temp_y = objetos[i].y;
						if (objetos[i].tipo == 2)
							temp_alto = objetos[i].alto;
						else
							temp_alto = 2; // Para naves de nivel 6, sólo es necesario borrar hasta una línea de bits que esté completa, como es la segunda, pues se va moviendo de 1 en 1 en y++

						temp_ancho = objetos[i].ancho;
						temp_sprite = objetos[i].sprite;
						
						if (objetos[i].tipo == 2){
							if (timeline % 128 == 0)
								objetos[i].temp = 0; //Resetear estrategia
							estrategiaInsector(&objetos[i]);//MOVIMIENTO. Diferentes estrategias: Acercarse, alejarse, juntarse, quedarse quieto.
						}
						else { // Naves Fase 6
							objetos[i].y++;
							if (objetos[i].y + 8 /*objetos[i].alto*/ > AREA_JUEGO_INFERIOR) {
								temp_alto = objetos[i].alto;
								objetos[i].x = cpct_rand() % 10;
								objetos[i].y = 42;
							}
						}

				}
			
			diferencia = objetos[i].z - objetos[0].z; // diferencia entre asteroide y nave en Dimensión no proyectada
			if (diferencia < -MARGEN_PLANO){ // Hay un margen de +- 10 puntos para determinar que está en otro plano
				switch (objetos[i].tipo) {
					case 1:	objetos[i].alto = objetos[i].alto_otro = 32;
						objetos[i].ancho = objetos[i].ancho_otro = 7;
						objetos[i].sprite = &G_Asteroide_g[0];
						break;
					case 2: 
						if (vista == VERTICAL) {
							objetos[i].alto = objetos[i].alto_otro = 36;
							objetos[i].ancho = objetos[i].ancho_otro = 6;
							if ((u16) objetos[i].sprite == (u16) G_Insector_V3_f0)
								objetos[i].sprite = &G_Insector_V3_f1[0]; //objetos[i].sprite_otro = G_Insector_H3_f1; 
							else 
								objetos[i].sprite = &G_Insector_V3_f0[0]; //objetos[i].sprite_otro = G_Insector_H3_f0; 
						} else { //HORIZONTAL
							objetos[i].alto = objetos[i].alto_otro = 18;
							if ((u16) objetos[i].sprite == (u16) G_Insector_H3_f0) {								
								objetos[i].sprite = &G_Insector_H3_f1[0]; //objetos[i].sprite_otro = G_Insector_V3_f1; 
								objetos[i].ancho = objetos[i].ancho_otro = 6;
							} else {
								objetos[i].sprite = &G_Insector_H3_f0[0]; //objetos[i].sprite_otro = G_Insector_V3_f0; 
								objetos[i].ancho = objetos[i].ancho_otro = 8;
							}
						}
						break;
				}
				
			} else if (diferencia > MARGEN_PLANO){
				switch (objetos[i].tipo) {
					case 1:	objetos[i].alto = objetos[i].alto_otro = 8;
						objetos[i].ancho = objetos[i].ancho_otro = 2;
						objetos[i].sprite = &G_Asteroide_p[0];
						break;
					case 2: 
						if (vista == VERTICAL) {
							objetos[i].alto = objetos[i].alto_otro = 20;
							objetos[i].ancho = objetos[i].ancho_otro = 4;
							if ((u16) objetos[i].sprite == (u16) G_Insector_V1_f0)
								objetos[i].sprite = &G_Insector_V1_f1[0]; 
							else
								objetos[i].sprite = &G_Insector_V1_f0[0]; 
						} else { //HORIZONTAL
							objetos[i].alto = objetos[i].alto_otro = 14;
							objetos[i].ancho = objetos[i].ancho_otro = 3;
							if ((u16) objetos[i].sprite == (u16) G_Insector_H1_f0)
								objetos[i].sprite = &G_Insector_H1_f1[0]; 
							else
								objetos[i].sprite = &G_Insector_H1_f0[0]; 
						}
						break;
				}
			} else { //MISMO PLANO
				switch (objetos[i].tipo) {
					case 1:objetos[i].alto = objetos[i].alto_otro = 16;
						objetos[i].ancho = objetos[i].ancho_otro = 4;
						objetos[i].sprite = objetos[i].sprite_otro = &G_Asteroide_m[0];
						break;
					case 2: 
						if (vista == VERTICAL) {
							objetos[i].alto = objetos[i].alto_otro = 28;
							objetos[i].ancho = objetos[i].ancho_otro = 5;
							if ((u16) objetos[i].sprite == (u16) G_Insector_V2_f0)
								objetos[i].sprite = &G_Insector_V2_f1[0];
							else
								objetos[i].sprite = &G_Insector_V2_f0[0]; 							
						} else { //HORIZONTAL
							objetos[i].alto = objetos[i].alto_otro = 16;
							if ((u16) objetos[i].sprite == (u16) G_Insector_H2_f0) {
								objetos[i].sprite = &G_Insector_H2_f1[0]; 
								objetos[i].ancho = objetos[i].ancho_otro = 5;
							} else {
								objetos[i].sprite = &G_Insector_H2_f0[0]; 
								objetos[i].ancho = objetos[i].ancho_otro = 6;
							}
						}
						break;
					}
			}
			objetos[i].x = recortar (objetos[i].x, MAYOR_QUE, ANCHO_PANTALLA - 1 - objetos[i].ancho);
			objetos[i].y = recortar (objetos[i].y, MAYOR_QUE, AREA_JUEGO_INFERIOR - objetos[i].alto);
			//Hay que vovler a comprobar límites por si hubo cambio de vista, los valores temp apuntarían al dibujado antes de cambiar
			temp_x = recortar (temp_x, MAYOR_QUE, ANCHO_PANTALLA - 1 - temp_ancho);
			temp_y = recortar (temp_y, MENOR_QUE, AREA_JUEGO_SUPERIOR_VAR);
			temp_y = recortar (temp_y, MAYOR_QUE, AREA_JUEGO_INFERIOR - temp_alto);
			
			
			//BORRAR anterior
			if (temp_alto)
				cpct_drawSpriteBlended_NAND (cpct_getScreenPtr(CPCT_VMEM_START, temp_x, temp_y), temp_alto, temp_ancho, temp_sprite);

			cpct_drawSpriteBlended (cpct_getScreenPtr(CPCT_VMEM_START, objetos[i].x, objetos[i].y), objetos[i].alto, objetos[i].ancho, objetos[i].sprite);
			//Hay que volver a poner las dimensiones del tamaño medio para que haga bien el cálculo de coordenadas en el cambio de vista. Si no, entran en el marcador
			switch (objetos[i].tipo) {
					case 1:objetos[i].alto = objetos[i].alto_otro = 16;
						objetos[i].ancho = objetos[i].ancho_otro = 4;
						break;
				}
		}
		else { //Mostrar explosión hasta marca temp == 127
			if (objetos[i].temp < 128)
				explosion(&objetos[i]);
		}
	}
}


void Laser(){
	//PINTAR LASER
	if (laser.temp)  {
		if (vista == VERTICAL) {
			if (laser.y == 0  && laser.x == 0) { 
				// Guardar desde donde se dispara para luego borrar
				laser.x = (objetos[0].x + 2 + objetos[0].offset);
				if (objetos[0].offset < 0)
					laser.x--; // Quitar una posición extra si estamos en posición derecha
				laser.y = objetos[0].y;
				laser.ancho = 1;
				laser.alto = 40;
				laser.sprite=&G_DisparoV[0];
				if (laser.y - laser.alto < AREA_JUEGO_SUPERIOR_VAR)
					laser.alto = laser.y - AREA_JUEGO_SUPERIOR_VAR;

				laser.y = laser.y - laser.alto;  //Porque se dibuja de arriba a abajo; la y debe comenzar donde termina el disparo, no donde está la nave
			}		
		}
		if (vista == HORIZONTAL) {
			if (laser.y == 0  && laser.x == 0) { 
				laser.x =  (objetos[0].x + objetos[0].ancho); 
				laser.y =  objetos[0].y + (objetos[0].alto/2) + 2;
				laser.ancho = 10; //40 / 4 por no tener proporción simétrica
				laser.alto = 1;
				laser.sprite=&G_DisparoH[0];
				if (laser.x + laser.ancho > ANCHO_PANTALLA - 1)
					laser.ancho = ANCHO_PANTALLA - laser.x - 1;
			}
			if (laser.ancho == 0) {
				laser.z = 0; // No se puede disparar está en el borde
			} else {
				laser.z--;			
			}
		}
		if (laser.alto == 0 || laser.ancho == 0){
			laser.z = laser.temp = 0; // No se puede disparar está en el borde. Marcar como si no se hubiese disparado
		} else {
			laser.z--; //restar TIMEOUT
		}
		if (laser.z > 0) {
			if (!explosion_FX)
				cpct_akp_SFXPlay (1, VOLUMEN_LASER, 90, 0, 0, AY_CHANNEL_B);

			cpct_drawSpriteBlended (cpct_getScreenPtr(CPCT_VMEM_START,laser.x,laser.y), laser.alto, laser.ancho, laser.sprite ); 
		}
	}
	//BORRAR LASER
	if (laser.temp && laser.z == 0) {
		if ((vista == VERTICAL && laser.alto) || (vista == HORIZONTAL && laser.ancho)) {
			cpct_drawSpriteBlended_NAND (cpct_getScreenPtr( CPCT_VMEM_START, laser.x, laser.y), laser.alto, laser.ancho, laser.sprite);
		}
		initLaser();
	}
	
}

void moverNave(u8 movimiento){
	//En Nivel 3 (túnel) no se redibuja sprite. Sólo se mueve el inicial
	u8 x_temp,y_temp,alto_temp,ancho_temp;
	const u8* sprite_temp;

	//movimiento = máscara con movimientos; 0000LRUP; L=Left; R=Right, ... 00001010 = 0x0A = Left + Up
	x_temp = objetos[0].x + objetos[0].offset;
	y_temp = objetos[0].y;
	alto_temp = objetos[0].alto;
	ancho_temp = objetos[0].ancho;
	sprite_temp = objetos[0].sprite;

	if (!explosion_FX) //Reproducir FX sólo si no está sonando el de la explosión
		cpct_akp_SFXPlay (3, VOLUMEN_NAVE, 30, 0, 0, AY_CHANNEL_B);

	if ((pressedLeft() && objetos[0].x > 0 && movimiento == 0) || movimiento & 8) {
		objetos[0].x--; 
				
		//if (nivel == 3 && objetos[0].x < ParedA.x && vista == VERTICAL) 
		if (nivel == 3 && objetos[0].x < 35 && vista == VERTICAL) //Para nivel 3, no se permite avanzar más del túnel
			objetos[0].x++;

		if (vista == VERTICAL && nivel != 3 && nivel != 6) {
			if (nivel < 4)
				objetos[0].sprite = G_NaveEscuelaV2I;
			else
				objetos[0].sprite = G_NaveBatallaV2I;

			objetos[0].alto = 36;
			objetos[0].ancho = 5;
			objetos[0].offset = 2;
		}
	
		if (vista == HORIZONTAL && !(pressedUp() || pressedDown() || movimiento & 2|| movimiento & 1)) { //Si a la vez pulsamos arriba o abajo, no cambiar sprite. Se usa el de arriba o abajo
			if (nivel < 4)
				objetos[0].sprite = G_NaveEscuelaH2;
			else
				objetos[0].sprite = G_NaveBatallaH2;

			objetos[0].alto = 16;
			objetos[0].ancho = 8;
			objetos[0].offset = 0;
		}
	} 

	if ((pressedRight() && ((vista == HORIZONTAL && objetos[0].x < 71) || (vista == VERTICAL && objetos[0].x < 74)) && movimiento == 0)  || movimiento & 4){ 
		objetos[0].x++; 
		
		if (nivel == 3)
			//if ((objetos[0].x > ParedA.x + ParedA.ancho && vista == VERTICAL) 
			if ((objetos[0].x > 37 && vista == VERTICAL)  //Para nivel 3 , no se permite avanzar más allá del túnel
				|| (objetos[0].x > 39 && vista == HORIZONTAL)) //Para nivel 3 (túnel), no se permite avanzar más de 39x porque la detección de colisiones sólo se hace con el primer tramo de 40 Bytes
			objetos[0].x--;

		if (vista == VERTICAL && nivel != 3 && nivel != 6) {
			if (nivel < 4)
				objetos[0].sprite = G_NaveEscuelaV2D;
			else
				objetos[0].sprite = G_NaveBatallaV2D;

			objetos[0].alto = 36;
			objetos[0].ancho = 5;
			objetos[0].offset = -1;
			}

		if (vista == HORIZONTAL && !(pressedUp() || pressedDown() || movimiento & 2|| movimiento & 1)) {
			if (nivel < 4)
				objetos[0].sprite = G_NaveEscuelaH2;
			else
				objetos[0].sprite = G_NaveBatallaH2;

			objetos[0].alto = 16;
			objetos[0].ancho = 8;
			objetos[0].offset = 0;
			}
	}

	if ((pressedUp() && objetos[0].y > AREA_JUEGO_SUPERIOR_VAR + 1 && movimiento == 0) || movimiento & 2){
		objetos[0].y--;objetos[0].y--; //Subir 2 px para que sea más proporcionado con el movimiento horizontal que mueve 1 byte (8px)
		
		if (nivel == 3)
			//if ((objetos[0].y < ParedA.y && vista == HORIZONTAL) //Para nivel 3 , no se permite avanzar más allá del túnel
			if ((objetos[0].y < 101 && vista == HORIZONTAL) //Para nivel 3 , no se permite avanzar más allá del túnel
				|| (objetos[0].y < 130 && vista == VERTICAL)) //Para nivel 3 (túnel), no se permite avanzar más del pixel 100 porque al cambiar vista podría acabar donde no se detecta colisión
			objetos[0].y+=2;

		if (nivel == 3 && objetos[0].y < 100 && vista == VERTICAL) //Para nivel 3 (túnel), no se permite avanzar más del pixel 100 porque al cambiar vista podría acabar donde no se detecta colisión
			objetos[0].y+=2;
		if (nivel == 6 && objetos[0].y < AREA_JUEGO_SUPERIOR_INI + 10) //Para nivel 6, no se permite avanzar más del pixel 52 para no tener que procesar colisión contra nave nodriza que llevaría muchos ciclos
			objetos[0].y+=2;

		if (vista == VERTICAL && !(pressedLeft() || pressedRight() || movimiento & 8|| movimiento & 4) && nivel != 3 && nivel != 6) {
			if (nivel < 4)
				objetos[0].sprite = G_NaveEscuelaV2;	
			else
				objetos[0].sprite = G_NaveBatallaV2;

			objetos[0].alto = 36;
			objetos[0].ancho = 6;
			objetos[0].offset = 0;
		}

		if (vista == HORIZONTAL && nivel != 3 ){
			if (nivel < 4)
				objetos[0].sprite = G_NaveEscuelaH2A;	
			else
				objetos[0].sprite = G_NaveBatallaH2A;

			objetos[0].alto = 19;
			objetos[0].ancho = 9;
			objetos[0].offset = 0;
		}
	}

	if ((pressedDown() && movimiento == 0 && (
				(vista == HORIZONTAL && objetos[0].y < AREA_JUEGO_INFERIOR - 20 )
				||(vista == VERTICAL && objetos[0].y < AREA_JUEGO_INFERIOR - 37 ) )
		)
		|| movimiento & 1){  //19px es la altura máxima de la nave en horizontal (tener en cuenta que y incrementa por 2), 39 en Vertical
		objetos[0].y++;objetos[0].y++;
		
		if (nivel == 3)
			//if (objetos[0].y > ParedA.y + ParedA.alto + 1 && vista == HORIZONTAL) //Para nivel 3 , no se permite avanzar más allá del túnel
			if (objetos[0].y > 101 + 2 + 1 && vista == HORIZONTAL) //Para nivel 3 , no se permite avanzar más allá del túnel
				objetos[0].y-=2;

		if (vista == VERTICAL && !(pressedLeft() || pressedRight() || movimiento & 8|| movimiento & 4) && nivel != 3 && nivel != 6) {
			if (nivel < 4)
				objetos[0].sprite = G_NaveEscuelaV2;
			else
				objetos[0].sprite = G_NaveBatallaV2;

			objetos[0].alto = 36;
			objetos[0].ancho = 6;
			objetos[0].offset = 0;
		}

		if (vista == HORIZONTAL && nivel != 3) {
			if (nivel < 4)
				objetos[0].sprite = G_NaveEscuelaH2B;
			else
				objetos[0].sprite = G_NaveBatallaH2B;

			objetos[0].alto = 19;
			objetos[0].ancho = 9;
			objetos[0].offset = 0;
		}
	}
	cpct_waitVSYNC();
	//BORRAR NAVE
	cpct_drawSpriteBlended_NAND (cpct_getScreenPtr( CPCT_VMEM_START, x_temp, y_temp), alto_temp, ancho_temp, sprite_temp);
	pintarNave();
}


void explosion(TObjeto *o){
	//x,y es el centro del objeto que va a explotar
	u8 x_final;
	u8 y_final;
	u8 ancho_max, alto_max;
	const u8 *sprite;

	ancho_max = 8;
	alto_max = 28;
	sprite = &G_Explosion_3[0];
	x_final = y_final = 0;
	
	if (o->temp < 41) { // [10..20) Primera explosión; [20..30) Segunda explosión; [30..40) Tercera explosión
		if (o->temp == 10)	{
			//cpct_akp_SFXStop (AY_CHANNEL_B); //Parar el FX que esté sonando 
			explosion_FX = 1;
			cpct_akp_SFXPlay (2, VOLUMEN_EXPLOSION, 36, 0, 0, AY_CHANNEL_B);
			}
		if (o->temp < 9 && o->temp < 20){
			//Primera explosión
			ancho_max = 2;
			alto_max = 7;
			sprite = &G_Explosion_1[0];
		} else if (o->temp > 19 && o->temp < 30){
			//Segunda explosión
			ancho_max = 6;
			alto_max = 24;
			sprite = &G_Explosion_2[0];
		} /*else if (o->temp > 29 && o->temp < 40 ){
			//Tercera explosión
			ancho_max = 8;
			alto_max = 28;
			sprite = &G_Explosion_3[0];
		}*/
		x_final = o->x + o->offset + (o->ancho/2); // Centro X del objeto a explotar
		if ((ancho_max/2) > x_final) //Evitar overflow. La explosión será mayor que el objeto, x_final = 0 para no tener valor negativo
			x_final = 0;
		else
			x_final = recortar(x_final - (ancho_max/2), MAYOR_QUE, ANCHO_PANTALLA - ancho_max); 
		
		y_final = o->y + (o->alto/2); // Centro Y del objeto a explotar
		if ((alto_max/2) + AREA_JUEGO_SUPERIOR_VAR > y_final ) //evitar overflow y que se pinte más arriba del área de juego
			y_final = AREA_JUEGO_SUPERIOR_VAR;
		else
			y_final = recortar (y_final - (alto_max/2), MAYOR_QUE, AREA_JUEGO_INFERIOR - alto_max);

		if ((o->temp % 2) == 0) {//Para dibujar explosión intermitente
			cpct_drawSpriteBlended (cpct_getScreenPtr(CPCT_VMEM_START, x_final, y_final), alto_max , ancho_max, sprite); 
		}
		else
			cpct_drawSpriteBlended_NAND (cpct_getScreenPtr(CPCT_VMEM_START, x_final, y_final), alto_max , ancho_max, sprite);  
		
		o->temp++;

		if (o->temp > 40) {
			o->temp = 127; //Marcar fin de animación 
		} 

	} 

	if (o->temp == 127) { //Fin de la explosión. Borrar
		//Borrar Objeto explotado y sprite de mayor explosión posible
		//cpct_drawSpriteBlended_NAND (cpct_getScreenPtr( CPCT_VMEM_START, o->x + o->offset, o->y), o->alto, o->ancho, o->sprite);
		//cpct_drawSpriteBlended_NAND (cpct_getScreenPtr( CPCT_VMEM_START, x_final, y_final), alto_max, ancho_max, sprite);
		//Borrar caja con dimensiones mínimas y máximas para borrar todo el área y tener en cuenta si la explosión es mas grande que el objeto o viceversa
		//No se puede hacer borrando sprite de explosión y objeto, porque si cambia la vista el sprite del objeto ya no es válido
		cpct_drawSolidBox (cpct_getScreenPtr(CPCT_VMEM_START, minimo(o->x + o->offset,x_final),minimo(o->y,y_final)),  0, maximo(o->ancho,ancho_max), maximo(o->alto,alto_max));
		o->temp++;
		if (o->tipo == 1 || o->tipo == 2){
			--enemigos;
			oleadas(); //Comprobar si se ha terminado una oleada para preparar siguiente
		}

		if (o->tipo == 0 && !cheat)
			vidas--;

		explosion_FX = 0;
		}
}

void disparosEnemigos(){
	u8 i;
	i16 x_temp,y_temp;
	cpct_waitVSYNC();

	for (i=1;i<total_elementos;i++){
		if ((objetos[i].temp < 10 && objetos[i].tipo == 2) || disparos[i].y) { // Sólo revisar los activos o disparos ya lanzados
			if (((nivel == 2 || nivel == 4) && enemigos < 6) || (nivel == 5)) {
			//Fases insectores, los primeros enemigos no disparan
				if (disparos[i].x == 0 && disparos[i].y == 0 ) {
					//nuevo disparo
					if (vista == VERTICAL) {
						disparos[i].x = objetos[i].x + (objetos[i].ancho/2);
						disparos[i].y = objetos[i].y + objetos[i].alto;
					} else {
						disparos[i].x = objetos[i].x;
						disparos[i].y = objetos[i].y + (objetos[i].alto/2);
					}

					x_temp = (objetos[0].x + objetos[0].offset + (objetos[0].ancho/2)) - disparos[i].x;
					y_temp = (objetos[0].y + (objetos[0].alto/2)) - disparos[i].y;

					if (abs(x_temp)>abs(y_temp) && abs(x_temp)/abs(y_temp) > 2){
						disparos[i].x_factor = abs(x_temp)/x_temp; //-1 o +1
						disparos[i].y_factor = 0;
					} else if (abs(x_temp)<abs(y_temp) && abs(y_temp)/abs(x_temp) > 2){
						disparos[i].x_factor = 0;
						disparos[i].y_factor = abs(y_temp)/y_temp; //-1 o +1
					} else {
						disparos[i].x_factor = abs(x_temp)/x_temp; 
						disparos[i].y_factor = abs(y_temp)/y_temp; 
					}

					disparos[i].vida = 0;
					disparos[i].x_ant = disparos[i].x;
					disparos[i].y_ant = disparos[i].y;
				} 

				disparos[i].vida++;

				// Si ha llegado al final de vida o choca con margenes, desaparecer disparo
				if (disparos[i].vida == MAX_DISPARO || disparos[i].x_ant == 0 || disparos[i].x_ant > ANCHO_PANTALLA - 2
					|| disparos[i].y_ant < AREA_JUEGO_SUPERIOR_VAR + 2 || disparos[i].y_ant > AREA_JUEGO_INFERIOR - 6){
					//BORRAR DISPARO ULTIMO DISPARO
					cpct_drawSpriteBlended_NAND (cpct_getScreenPtr( CPCT_VMEM_START, disparos[i].x_ant, disparos[i].y_ant), 4, 1, disparo_sprite);
					disparos[i].x = disparos[i].y = 0;
				}
				else {
					x_temp=disparos[i].x + (disparos[i].vida*disparos[i].x_factor);
					y_temp=disparos[i].y + (disparos[i].vida*disparos[i].y_factor);
					//BORRAR DISPARO
					cpct_drawSpriteBlended_NAND (cpct_getScreenPtr( CPCT_VMEM_START, disparos[i].x_ant, disparos[i].y_ant), 4, 1, disparo_sprite);
					//PINTAR DISPARO				
					cpct_drawSpriteBlended (cpct_getScreenPtr(CPCT_VMEM_START, x_temp, y_temp), 4 , 1, disparo_sprite); 
					disparos[i].x_ant = x_temp;
					disparos[i].y_ant = y_temp;
				}	
			}
			
		}
	}
}

//Sacado de cpcwiki/forum

cpct_keyID getKey() {
  // Traverse the keystatus vector from end to start, to help
  // the compiler better optimize this code
  u8 i = 10, *keys = cpct_keyboardStatusBuffer + 9;
  u16 keypressed;
 
  // Analyse which key has been pressed and return its keycode
  do {
    // We analyse groups of keys byte by byte (8 by 8, 1 bit per key)
    // If no single key is pressed in this group, all bits will be on, and the byte will be 0xFF
    // Then, XORing the byte with 0xFF will result in 0 unless some key from this group is pressed
    keypressed = *keys ^ 0xFF;
    if (keypressed)
       return (keypressed << 8) + (i - 1); // Convert to cpct_keyID format: 8 first bits = key mask, 8 next bits, keyboard row (0-9)
    --keys;
  } while(--i);

  // No key was pressed
  return 0;
}

/*void cpct_drawSpriteBlended_NAND_antigua (u8* memory, u8 height, u8 width, const u8* sprite) {
	
	u8 i,j, *pvmem;
	const u8 *byte_sprite;

	pvmem = memory;
	byte_sprite = sprite;
	for (i=0; i<height;i++){
		for (j=0; j<width; j++){
			*(pvmem + j) = ~(*byte_sprite) & *(pvmem + j);
			
			byte_sprite++;
		}
		pvmem += 0x0800; //Siguiente línea
		//direccion = (u16) pvmem ; //Obtener 
		if (!((u16) pvmem & 0x3800)){ //Detectar si la dirección resultante lleva a final de línea de 8 bits => cambiar de banco de vídeo
			pvmem += 0xC050;
			// Ir al siguiente Banco es, después del overflow, volver a la posición inicial del vídeo y sumar 50
			// F800 + 800 = 0000 + C000 + 50 = C050
		}
	}*/
