#include <cpctelera.h>
#include <stdio.h>
#include <string.h>
//#include "graficos/Banderas.h"
#include "graficos/Sprites_rgas.h"
#include "main.h"
#include "funciones.h"
#include "consola.h"
#include "intro.h"
#include "fonts.h"
#include "musica/m_intro.h"

typedef struct {
	u8 x, y, pintado, tipo;
} TEstrella;


//Los sprites de las estrellas de fondo siempre tienen que ser de 1 byte por ser modo 2.
//Se ponen en situaciones diferentes para que no colisionen entre ellos
//1000 0000  x80
//
//0011 0000  x30
//0011 0000  x30
//
//0000 0110	 x06
//0000 1111	 x0F
//0000 1111	 x0F
//0000 0110	 x06
const u8 estrella_p[1] = {
	0x80  // estrella de tamaño 1 pixel 
};

const u8 estrella_m[2] = {
	0x30 , 0x30   // estrella de tamaño 2x2 pixels
};

//Variables
TEstrella estrellas[MAX_ESTRELLAS];

u8 salir;

void intHandler(){
	//Las interrupciones saltan 300 por segundo (Hz), como la música está diseñada en 50Hz
	//debe llamarse a musciPlay cada 6 veces que llegue la interrupción
	if (contador_musica % 6 == 0 && !musica){
		cpct_akp_musicPlay();
	}
	contador_musica++;
	speedrun++;
}


void setInterruptAtVSYNCStart(void *intHdl){
	//Asegurarnos que cambiamos la gestión de interrupciones es al terminar VSync
	//pues el primero puede saltar si estamos a mitad de VSync. Por eso se pasan 2 interrupciones más
	//y entra en espera. Ahora es seguro que saltará de la espera al llegar el CRTC al VSync
	cpct_waitVSYNC();
	__asm
		halt
		halt
	__endasm;
	cpct_waitVSYNC();//Nos aseguramos que CRTC estaba a mitad de pantalla
	cpct_setInterruptHandler(intHdl);
}

/*void menuIdiomas(){

	cpct_setVideoMode(1);
	cpct_setPalette(b_palette,4);
	cpct_clearScreen_f64(0x0000);

	// Banderas 14x10 pixels. Al ser modo 0, serán 7 bytes de ancho
   	cpct_drawStringM1 ("1-Spanish",  cpctm_screenPtr (CPCT_VMEM_START, 5, 5), 3, 0);
   	cpct_drawSprite (b_Banderas_0, cpct_getScreenPtr(CPCT_VMEM_START, 25,5) , B_BANDERAS_0_W, B_BANDERAS_0_H);

	cpct_drawStringM1 ("2-English", cpctm_screenPtr (CPCT_VMEM_START, 5, 20), 3, 0);
   	cpct_drawSprite (b_Banderas_1, cpct_getScreenPtr(CPCT_VMEM_START, 25,20), B_BANDERAS_0_W, B_BANDERAS_0_H);
   	
   	salir = 1;
   	while (!tecladoPulsado()){
   		;
   	}

	if (cpct_isKeyPressed(Key_1)){
		idioma = ESP;
	} else if (cpct_isKeyPressed(Key_2)){
		idioma = ENG;
	}  else {
		idioma = ESP;
	}
}*/

void dibujarFondo() {
//Dibujar la pantalla de presentación: Luna, Nave y Título
	
	//Luna 120*60
	cpct_drawSpriteBlended(cpct_getScreenPtr(CPCT_VMEM_START, 0, 102),80,20,G_Luna_Grande);

	//Nave 176*57
 	cpct_drawSpriteBlended(cpct_getScreenPtr(CPCT_VMEM_START, 57, AREA_JUEGO_SUPERIOR_INI),57,22,G_NaveIntro);

	//Título 176*40
	cpct_drawSpriteBlended(cpct_getScreenPtr(CPCT_VMEM_START, 29, 80),40,22,G_Logo);
}

void dibujarEstrellas() {
//Animación de estrellas que simulan parpadear. Se tiene en cuenta dibujo de fondo para que no se pinte sobre él	
	u8 pintar;

	for (int i=0;i<MAX_ESTRELLAS;i++){
		pintar = 0;
		if (!salir)
			salir = tecladoPulsado();
		
		//Si y == 0 (valor inicial), crear nueva estrella; o donde se va a pintar no tiene fondo negro, no se puede pintar ahí
		if (estrellas[i].pintado == 0) {
			if (estrellas[i].y == 0 || ((estrellas[i].tipo == 0 &&  (*cpct_getScreenPtr(CPCT_VMEM_START, estrellas[i].x, estrellas[i].y)) != 0)
				|| (estrellas[i].tipo == 1 && (*cpct_getScreenPtr(CPCT_VMEM_START, estrellas[i].x, estrellas[i].y) != 0 
											|| *cpct_getScreenPtr(CPCT_VMEM_START, estrellas[i].x, (estrellas[i].y+1)) != 0))
				|| (estrellas[i].tipo == 2 && (*cpct_getScreenPtr(CPCT_VMEM_START, estrellas[i].x, estrellas[i].y) != 0 
											|| *cpct_getScreenPtr(CPCT_VMEM_START, estrellas[i].x, (estrellas[i].y+1)) != 0
											|| *cpct_getScreenPtr(CPCT_VMEM_START, estrellas[i].x, (estrellas[i].y+2)) != 0
											|| *cpct_getScreenPtr(CPCT_VMEM_START, estrellas[i].x, (estrellas[i].y+3)) != 0))) 	){
				estrellas[i].x = RandomX(); 
				estrellas[i].y = RandomY(0);
				estrellas[i].tipo=cpct_rand()%3; 
			} else {
				//Pintar estrella
				pintar = 1;
				estrellas[i].pintado = 1;
			}
		} else {
			// Borrar estrella, pintándola de nuevo con XOR
			cpct_setBlendMode(CPCT_BLEND_XOR);
			pintar = 1;
			estrellas[i].pintado = 0;			
		}

		if (pintar) { //Es la misma instrucción pintar que borrar, dependerá del BlendMode indicado
			if (estrellas[i].tipo == 0)
				cpct_drawSpriteBlended (cpct_getScreenPtr(CPCT_VMEM_START, estrellas[i].x, estrellas[i].y), 1 , 1, estrella_p); 
			else if (estrellas[i].tipo == 1)
				cpct_drawSpriteBlended (cpct_getScreenPtr(CPCT_VMEM_START, estrellas[i].x, estrellas[i].y), 2 , 1, estrella_m); 
			else
				cpct_drawSpriteBlended (cpct_getScreenPtr(CPCT_VMEM_START, estrellas[i].x, estrellas[i].y), 4 , 1, disparo_sprite); 

			cpct_setBlendMode(CPCT_BLEND_OR);
			if (!estrellas[i].pintado) { //Ya se ha borrado, calcular nueva posición
				estrellas[i].x = RandomX();
				estrellas[i].y = RandomY(0);
				estrellas[i].tipo = cpct_rand() % 3; 		
			}
		}	
	}
}


void introHistoria() {
//Pantalla de presentación: arranca la música, inicializa estrellas, muestra fondo y texto. Queda a la espera de que el jugador pulse tecla
	u32 semilla;
	//cpct_clearScreen_f64(0x0000);
	cpct_setVideoMode(2);
  	cpct_setPalette(paletaM2,2);	
	borrarPantalla();

	cpct_akp_SFXInit (m_sfx);
	cpct_akp_musicInit(m_intro);
	setInterruptAtVSYNCStart(intHandler);

	//inicializar estrellas
	for (int i=0;i<MAX_ESTRELLAS;i++){
		estrellas[i].y=0;
		estrellas[i].pintado=0;
	}

	salir = 0;
	semilla = 0;
	dibujarFondo();
	txtInfCreditos();

	if (nivel) // Ya se ha jugado una partida al juego
		f_teletipo = 0; //Para que aparezca el texto ya escrito, sin teletipo
	else
		f_teletipo = 1; //Para escribir texto de intro como si fuera un teletipo
	
	txtSupIntro();	
	
	
	pausaTecladoLibre();
   	while (!salir) { 		
   		dibujarEstrellas();	
   		semilla++;  //Para cambiar fuente de entropía para números aleatorios
   	}
   	cpct_akp_stop();

   	if (!semilla)
   		semilla = 1; //La semilla no puede ser 0

   	cpct_srand8(semilla); //Para asegurar aleatoriedad de verdad. Si no, con cada carga del juego la primera posición de los asteroides de la fase 1 era siempre igual
}

void pintarTablaPuntuacion(){
//Pinta cuadro de puntuaciones sobre recuadro	
	u8 i,j;
	u8 linea[23];
	u16 temp;

	cpct_drawSolidBox (cpct_getScreenPtr(CPCT_VMEM_START, 26, 71), 255, 28, 90); 
	cpct_drawSolidBox (cpct_getScreenPtr(CPCT_VMEM_START, 27, 72), 0  , 26, 88);
	
	f_teletipo = 0;
	for (i=0; i<8; i++){
		//Copiar nombre
		for (j=0;j<6;j++)
			linea[j] = scoreboard[i].nombre[j];

		for (j=0;j<11;j++)
			linea[6+j] = 42;

		temp = scoreboard[i].puntuacion;

		linea[17] = temp / 100;
		temp = temp % 100;
		linea[18] = temp / 10;
		temp = temp % 10;
		linea[19] = temp;
		linea[20] = 0;// No hay decenas ni unidades de punto. Siempre 0
		linea[21] = 0;
		linea[22] = 255; //Fin de línea

		f_c = cpct_getScreenPtr(CPCT_VMEM_START, 29, 76+(i*10));	
		myDrawString(linea);
	}
}


void hiscores() {
//Mostrar puntuación final, tabla de puntuaciones y recoger nombre	
	u8 contador,dummy;
	TScoreboard temp;
	cpct_keyID tecla;
	u8 nombre[7];

	
	borrarPantalla();

	cpct_akp_musicInit(m_intro);
	
	txtSupPuntuacionFinal();
	
	salir = 0;
	dibujarFondo();
	//Repintar logo en otra posición, en la posición original queda tapado por la tabla de puntuaciones
	cpct_drawSpriteBlended(cpct_getScreenPtr(CPCT_VMEM_START, 29, 25),40,22,G_Logo);

	if (puntuacion >= scoreboard[7].puntuacion) {
		pintarTablaPuntuacion();
		txtInfNombrePuntuacion();
		contador = 0;
	} else
		contador = 6;

	pausaTecladoLibre();
	
   	while (contador < 6) { 		
   		if (tecladoPulsado()) {
   			tecla = getKey();
   			dummy = 255;
   			cpct_akp_SFXPlay (1, 10, 90, 0, 0, AY_CHANNEL_B);
   		
	   		if (tecla == Key_0) 		dummy = 0; 
	   		if (tecla == Key_1) 		dummy = 1; 
	   		if (tecla == Key_2) 		dummy = 2; 
	   		if (tecla == Key_3) 		dummy = 3; 
	   		if (tecla == Key_4) 		dummy = 4; 
	   		if (tecla == Key_5) 		dummy = 5; 
	   		if (tecla == Key_6) 		dummy = 6; 
	   		if (tecla == Key_7) 		dummy = 7; 
	   		if (tecla == Key_8) 		dummy = 8; 
	   		if (tecla == Key_9) 		dummy = 9; 
	   		if (tecla == Key_A) 		dummy = 10; 
	   		if (tecla == Key_B) 		dummy = 11; 
	   		if (tecla == Key_C) 		dummy = 12; 
	   		if (tecla == Key_D) 		dummy = 13; 
	   		if (tecla == Key_E) 		dummy = 14; 
	   		if (tecla == Key_F) 		dummy = 15; 
	   		if (tecla == Key_G) 		dummy = 16; 
	   		if (tecla == Key_H) 		dummy = 17; 
	   		if (tecla == Key_I) 		dummy = 18; 
	   		if (tecla == Key_J) 		dummy = 19; 
	   		if (tecla == Key_K) 		dummy = 20; 
	   		if (tecla == Key_L) 		dummy = 21; 
	   		if (tecla == Key_M) 		dummy = 22; 
	   		if (tecla == Key_N) 		dummy = 23; 
	   		if (tecla == Key_O) 		dummy = 24; 
	   		if (tecla == Key_P) 		dummy = 25; 
	   		if (tecla == Key_Q) 		dummy = 26; 
	   		if (tecla == Key_R) 		dummy = 27; 
	   		if (tecla == Key_S) 		dummy = 28; 
	   		if (tecla == Key_T) 		dummy = 29; 
	   		if (tecla == Key_U) 		dummy = 30; 
	   		if (tecla == Key_V) 		dummy = 31; 
	   		if (tecla == Key_W) 		dummy = 32; 
	   		if (tecla == Key_X) 		dummy = 33; 
	   		if (tecla == Key_Y) 		dummy = 34; 
	   		if (tecla == Key_Z) 		dummy = 32; 
	   		if (tecla == Key_Space)	dummy = 45; 
	   		if (tecla == Joy0_Fire1) 	dummy = 48; 

	   		if (dummy != 255){
	   			nombre[contador++] = dummy;
	   		}

	   		if (tecla == Key_Return || tecla == Key_Enter) {
   				while (contador < 6)
   					nombre[contador++] = 45; 
   			}

   			nombre[contador] = 255;

   			if (tecla == Key_Del && contador > 0) 
   				nombre[--contador] = 45; //Borrar anterior carácter

   			pausaTecladoLibre();
   			
   			f_teletipo = 0;
   			f_c = cpct_getScreenPtr(CPCT_VMEM_START, 20, 187);	
			myDrawString(nombre);
   		}
   	}
   	if (nombre[0] == 12 && nombre[1] == 25 && nombre[2] == 12 && nombre[3] == 13 && nombre[4] == 14 && nombre[5] == 31){
   		cpct_akp_SFXPlay (1, 15, 40, 0, 0, AY_CHANNEL_B);
   		cheat = 1;
   	}

   	// Actualizar Scoreboard
   	for (contador = 0; contador < 8; contador++){
   		if (puntuacion >= scoreboard[contador].puntuacion){
   			temp.puntuacion = scoreboard[contador].puntuacion; 
   			for (dummy=0;dummy<6;dummy++) 
   				temp.nombre[dummy] = scoreboard[contador].nombre[dummy];

   			scoreboard[contador].puntuacion = puntuacion; 
   			for (dummy=0;dummy<6;dummy++) 
   				scoreboard[contador].nombre[dummy] = nombre[dummy];

   			puntuacion = temp.puntuacion; 
   			for (dummy=0;dummy<6;dummy++) 
   				nombre[dummy] = temp.nombre[dummy];
   		}
   	}
   	
   	pintarTablaPuntuacion();
   	f_c = cpct_getScreenPtr(CPCT_VMEM_START, 2, 187);	
   	initTxtInferior();
   	f_teletipo = 1;
   	txtInfContinuar();
}

