// Estructuras
typedef struct {
	u8 x,y,z; //coordenadas 3D
	const u8* sprite;
	const u8* sprite_otro; //sprite para ambas vistas
	u8 alto, alto_otro; //alto del sprite
	u8 ancho, ancho_otro; //ancho del sprite
	i8 offset, offset_otro; //offset para recolocar coordenadas
	u8 temp; // variable libre para cada tipo de objeto
	u8 tipo; // 0: Nave; 1: Asteroide; 2: Insector
} TObjeto;

typedef struct {
	u8 x,y; //coordenadas actuales. Por simplificar los disparos siempre estarán en el mismo plano que la nave
	u8 x_ant,y_ant; //guardar coordenadas que se tienen que borrar, para aligerar código
	i8 x_factor, y_factor; //factor para la recta de la trayectoria
	u8 vida; //duración del disparo
} TDisparo;

typedef struct {
	u16 puntuacion;
	char nombre[6]; //max 6 caracteres para nombre
} TScoreboard;

//Constantes
#define ESP 1 // Idioma del juego
#define ENG 2

#define VERTICAL 0 //Vista del juego
#define HORIZONTAL 1
#define ANCHO_PANTALLA 80 //Ancho de pantalla (se indica en bytes)
#define ALTO_PANTALLA 200 //Alto de pantalla (se indica en pixels)
#define AREA_JUEGO_SUPERIOR_INI 42 //Aunque el área de juego superior es variable declaro este define porque en algunos sitios siempre se usará el primer valor y así ahorrar código
#define AREA_JUEGO_INFERIOR 181
#define LIMITE_DERECHA ANCHO_PANTALLA - 7  // obsoleto?
#define LIMITE_ABAJO ALTO_PANTALLA - 22 // obsoleto?
#define MAX_ESTRELLAS 80 // Máximas estrellas por tipo
#define MAX_ELEMENTOS 7 // Máximos elementos activos por fase
#define MARGEN_PLANO 10 //Márgen para indicar si un objeto está en el mismo plano que la nave o no
#define TIMEOUT_DISPARO 10
#define MAX_ESTRATEGIAS 4
#define MAX_DISPARO 40
#define MENOR_QUE 0
#define MAYOR_QUE 1
#define LIMITE_NIVEL3 90
#define VOLUMEN_LASER 9
#define VOLUMEN_NAVE 7
#define VOLUMEN_EXPLOSION 10

extern const u8 disparo_sprite[4];
extern const TObjeto NaveValoresIniciales;

extern __at(0x0040) const unsigned char m_sfx[208]; 


extern u8 vidas; 
extern u8 nivel; 
extern u16 puntuacion;	
extern u8 total_elementos; 
extern u8 vista; 
//extern u8 idioma; //Guardar el idioma que selecciona el usuario
extern TObjeto laser; 
extern u8 enemigos; 
extern u8 AREA_JUEGO_SUPERIOR_VAR; 
extern TObjeto ParedA; 
extern TObjeto ParedB; 
extern u16 timeline; 
extern u32 speedrun; 
extern TObjeto objetos[MAX_ELEMENTOS] ;
extern TDisparo disparos[MAX_ELEMENTOS];
extern TScoreboard scoreboard[8];

extern u8 paredIzq[(AREA_JUEGO_INFERIOR - LIMITE_NIVEL3)  * 2];
extern u8 paredDer[(AREA_JUEGO_INFERIOR - LIMITE_NIVEL3)  * 2];
extern u8 paredArr1[ANCHO_PANTALLA]; 
extern u8 paredArr2[ANCHO_PANTALLA];
extern u8 paredAba1[ANCHO_PANTALLA];
extern u8 paredAba2[ANCHO_PANTALLA];

extern u8 cheat;

//Aprovechar bytes que no se usan en la memoria de vídeo para meter variables globales
extern __at(0xC7D0) u8 explosion_FX;
extern __at(0xC7D1) u8 speedrun_digitos[4];
extern __at(0xC7D5) u8 contador_musica; 
extern __at(0xC7D6) u8 vista_pulsada; 
extern __at(0xC7D7) u8 musica;
extern __at(0xC7D8) f32 factor_vista; 
extern __at(0xCFD0) i8 estrategias[MAX_ESTRATEGIAS]; 
extern void debug_buddy(u32 value, u8 key);
extern __at(0xFFD0) u32 debug_value;
extern __at(0xFFD4) u8 debug_key;